//%attributes = {"invisible":true}
C_TEXT:C284($1;$controlName)
C_OBJECT:C1216($2;$message)

$controlName:=$1
$message:=$2

C_POINTER:C301($controlPtr)
$controlPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$controlName)

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	C_LONGINT:C283($areaRef)
	$areaRef:=OB Get:C1224($context;"_area_ref")
	
	C_TEXT:C284($what)
	$what:=OB Get:C1224($message;"what";Is text:K8:3)
	
	Case of 
		: ($what="_setup")
			
			C_BOOLEAN:C305($controlVisible)
			$controlVisible:=OB Get:C1224($context;"_control_visible";Is boolean:K8:9)
			
			C_TEXT:C284($areaName)
			$areaName:=OB Get:C1224($context;"_area_name";Is text:K8:3)
			
			OBJECT SET VISIBLE:C603(*;$controlName;$controlVisible)
			  //OBJECT SET VISIBLE(*;$areaName;$controlVisible)
			
		: ($what="_build")
			
			EXECUTE METHOD IN SUBFORM:C1085($controlName;"Menubar_Build_S";*;$context)
			EXECUTE METHOD IN SUBFORM:C1085($controlName;"Toolbar_Build_S";*;$context;$controlPtr)
			
			ImgControl_UpdateLayout ($controlName)
			
			EXECUTE METHOD IN SUBFORM:C1085($controlName;"Sidebar_Load_S";*;$areaRef)
			
		: ($what="_show_area")
			
			  //TRACE
			
			C_TEXT:C284($areaName)
			$areaName:=OB Get:C1224($context;"_area_name";Is text:K8:3)
			
			  //C_BOOLEAN($isVisible)
			  //$isVisible:=OBJECT Get visible(*;$areaName)
			
			OBJECT SET VISIBLE:C603(*;$areaName;True:C214)
			
		: ($what="UpdateState")
			
			ImgControl_UpdateState ($controlName)
			
		: ($what="ImageUnloaded")
			
			  // Reset sidebar
			EXECUTE METHOD IN SUBFORM:C1085($controlName;"Sidebar_Load_S";*;$areaRef)
			
		: ($what="ImageLoaded")
			
			OB REMOVE:C1226($context;"_saving_options")
			
			  // Load sidebar
			EXECUTE METHOD IN SUBFORM:C1085($controlName;"Sidebar_Load_S";*;$areaRef)
			
		: ($what="ImageReloaded")
			
			  // Load sidebar
			EXECUTE METHOD IN SUBFORM:C1085($controlName;"Sidebar_Load_S";*;$areaRef)
			
		: ($what="FrameIndex")
			
			  // Reveal thumb in sidebar
			EXECUTE METHOD IN SUBFORM:C1085($controlName;"Sidebar_Reveal_S";*;$context)
			
		: ($what="FrameChanged")
			
			C_LONGINT:C283($currentFrame)
			$currentFrame:=ImgArea_GetFrameIndex:P11667:42 ($areaRef)
			If ($currentFrame>0)
				EXECUTE METHOD IN SUBFORM:C1085($controlName;"Sidebar_ReloadCurrent_S";*;$areaRef)
			End if 
			
		: ($what="ToggleSidebar")
			
			C_BOOLEAN:C305($sidebarVisible)
			$sidebarVisible:=ImgControl_IsPartVisible ($controlName;"sidebar")
			ImgControl_SetPartVisible ($controlName;"sidebar";Not:C34($sidebarVisible))
			
		: ($what="ImageSaved")
			
			  // Load sidebar
			EXECUTE METHOD IN SUBFORM:C1085($controlName;"Sidebar_Load_S";*;$areaRef)
			
		Else 
			
			ASSERT:C1129(False:C215;"Unhandled image controller message.")
			
	End case 
	
End if 
