//%attributes = {"invisible":true,"shared":true}
#DECLARE($actionName : Text; $message : Text; $context : cs:C1710.CallbackContext)->$status : Object

var $imgControl : cs:C1710.ImgWidget
$imgControl:=$context.imgControl

var $areaRef : Integer
$areaRef:=$context.areaRef

var $docRef : Text
$docRef:=$context.docRef

var $frameIdx; $frameCount : Integer
$frameIdx:=$context.frameIndex
$frameCount:=$context.frameCount

$status:=New object:C1471
$status.enabled:=False:C215

If ($docRef#"")
	
	Case of 
		: ($message="status")
			
			Case of 
				: (($actionName="img_nav_first") | ($actionName="img_nav_prev"))
					
					$status.enabled:=($frameIdx>1) & ($frameCount>1)
					
				: (($actionName="img_nav_next") | ($actionName="img_nav_last"))
					
					$status.enabled:=($frameIdx<$frameCount) & ($frameCount>1)
					
				: ($actionName="img_nav_goto")
					
					$status.enabled:=($frameCount>1)
					$status.value:=$frameIdx
					$status.displayValue:=String:C10($frameIdx)+"/"+String:C10($frameCount)
					$status.minValue:=1
					$status.maxValue:=$frameCount
					
			End case 
			
		: ($message="action")
			
			Case of 
				: ($actionName="img_nav_first")
					
					$imgControl.setFrameIndex(1)
					
				: ($actionName="img_nav_prev")
					
					$imgControl.setFrameIndex($frameIdx-1)
					
				: ($actionName="img_nav_next")
					
					$imgControl.setFrameIndex($frameIdx+1)
					
				: ($actionName="img_nav_last")
					
					$imgControl.setFrameIndex($frameCount)
					
				: ($actionName="img_nav_goto")
					
					If ($context.args.value#Null:C1517)
						
						C_LONGINT:C283($targetIdx)
						//$targetIdx:=Int(Num($context.value))
						$targetIdx:=$context.args.value
						
						If (($targetIdx>=1) & ($targetIdx<=$frameCount) & ($targetIdx#$frameIdx))
							$imgControl.setFrameIndex($targetIdx)
						End if 
						
					End if 
					
			End case 
			
	End case 
	
End if 
