//%attributes = {"invisible":true,"shared":true}
C_TEXT:C284($1; $message)
C_TEXT:C284($2; $command)
C_OBJECT:C1216($3; $env)
C_OBJECT:C1216($0; $status)

$message:=$1
$command:=$2
$env:=$3

C_OBJECT:C1216($context)
$context:=$env.context

C_TEXT:C284($docRef; $docFormat)
$docRef:=$env.docRef
$docFormat:=$env.docFormat

$status:=New object:C1471

If ($docRef#"")
	
	C_TEXT:C284($filePath)
	$filePath:=ImgDoc_GetFilePath($docRef)
	
	Case of 
		: ($command="img_save")
			
			Case of 
				: ($message="status")
					
					C_BOOLEAN:C305($needsSaving)
					
					If ($filePath#"")  // File-backed
						
						$needsSaving:=($env.docEdits#0)
						
					Else   // BLOB-backed or new
						
						C_LONGINT:C283($dataSize)
						$dataSize:=ImgDoc_GetDataSize($docRef)
						
						If ($dataSize>0)  // BLOB-backed
							$needsSaving:=True:C214
						Else 
							$needsSaving:=($env.frameCount>0)
						End if 
						
					End if 
					
					$status.enabled:=$needsSaving
					
				: ($message="action")
					
					C_OBJECT:C1216($docFormatInfo)
					$docFormatInfo:=ImgFormat_GetInfo($docFormat)
					
					C_OBJECT:C1216($savingOptions)
					C_BOOLEAN:C305($promptDestFile; $promptSavingOptions)
					C_TEXT:C284($destPOSIXPath)
					
					If ($filePath#Null:C1517)
						
						If ($docFormatInfo.CanEncode)
							
							If ($context._saving_options#Null:C1517)
								
								$savingOptions:=OB Copy:C1225($context._saving_options)
								$promptSavingOptions:=False:C215
								
							Else 
								$savingOptions:=New object:C1471("Format"; $docFormat)
								$promptSavingOptions:=False:C215
							End if 
							
							$promptDestFile:=False:C215
							$destPOSIXPath:=$filePath
							
						Else 
							$savingOptions:=New object:C1471("Format"; $docFormat)  // Should be set to TIFF???
							$promptSavingOptions:=True:C214
							$promptDestFile:=True:C214
						End if 
						
					Else 
						$savingOptions:=New object:C1471("Format"; "TIFF")
						$promptSavingOptions:=True:C214
						$promptDestFile:=True:C214
					End if 
					
					ImgCtlCtx_Save($context; $docRef; $destPOSIXPath; $savingOptions; $promptSavingOptions; $promptDestFile)
					
			End case 
			
		: ($command="img_save_as")
			
			Case of 
				: ($message="status")
					
					$status.enabled:=True:C214
					
				: ($message="action")
					
					
					C_OBJECT:C1216($savingOptions)
					C_BOOLEAN:C305($promptDestFile; $promptSavingOptions)
					C_TEXT:C284($destPOSIXPath)
					
					If ($filePath#Null:C1517)
						
						$promptDestFile:=True:C214
						$promptSavingOptions:=True:C214
						
						If ($context._saving_options#Null:C1517)
							$savingOptions:=OB Copy:C1225($context._saving_options)
						Else 
							$savingOptions:=New object:C1471("Format"; $docFormat)
						End if 
						
					Else 
						$savingOptions:=New object:C1471("Format"; "TIFF")
						$promptSavingOptions:=True:C214
						$promptDestFile:=True:C214
					End if 
					
					ImgCtlCtx_Save($context; $docRef; $destPOSIXPath; $savingOptions; $promptSavingOptions; $promptDestFile)
					
			End case 
			
	End case 
	
End if 

$0:=$status
