//%attributes = {"invisible":true,"shared":true}
C_OBJECT:C1216($1; $context)
C_TEXT:C284($2; $op)
C_TEXT:C284($3; $command)
C_OBJECT:C1216($4; $args)
C_LONGINT:C283($0; $cmdStatus)

$context:=$1
$op:=$2
$command:=$3
If (Count parameters:C259>3)
	$args:=$4
End if 

$cmdStatus:=0

C_LONGINT:C283($areaRef)
$areaRef:=OB Get:C1224($context; "_area_ref"; Is longint:K8:6)

C_TEXT:C284($docRef)
$docRef:=ImgArea_GetDocument:P11667:41($areaRef)

C_TEXT:C284($format)
$format:=ImgDoc_GetFormat:P11667:9($docRef)

C_LONGINT:C283($frameIdx)
$frameIdx:=ImgArea_GetFrameIndex:P11667:42($areaRef)

C_TEXT:C284($xmpDataRef)
If ($format#"PDF")
	$xmpDataRef:=RasterFrame_CopyXMPData:P11667:27($docRef; $frameIdx)
Else 
	$xmpDataRef:=PDFDoc_CopyXMPData:P11667:32($docRef)
End if 

Case of 
	: ($op="status")
		
		$cmdStatus:=0x0001*Num:C11($xmpDataRef#"")
		
	: ($op="run")
		
		If ($xmpDataRef#"")
			
			C_TEXT:C284($filePath; $windowTitle)
			$filePath:=ImgDoc_GetFilePath($docRef)
			
			If ($filePath#"")
				var $file : 4D:C1709.File
				$file:=File:C1566($filePath; fk posix path:K87:1)
				$windowTitle:="XMP Metadata: "+$file.fullName  //FSRef_GetName($fileRef)
			Else 
				$windowTitle:="XMP Metadata"
			End if 
			
			If ($format#"PDF")
				If (ImgDoc_GetFrameCount:P11667:11($docRef)>1)
					$windowTitle:=$windowTitle+" / Page "+String:C10($frameIdx)
				End if 
			End if 
			
			C_OBJECT:C1216($options)
			OB SET:C1220($options; "WindowTitle"; $windowTitle)
			
			If (Shift down:C543 & Not:C34(Is compiled mode:C492(*)))
				OB SET:C1220($options; "DevMode"; True:C214)
			End if 
			
			C_LONGINT:C283($success)
			$success:=XMPDlog_EditData($xmpDataRef; $options)
			If ($success=1)
				
				If ($format#"PDF")
					RasterFrame_SetXMPData($docRef; $frameIdx; $xmpDataRef)
				Else 
					// FIXME: PDF XMP assignment
				End if 
			End if 
			
		End if 
		
End case 

If ($xmpDataRef#"")
	ImgObj_Release:P11667:133($xmpDataRef)
End if 

If ($docRef#"")
	ImgObj_Release:P11667:133($docRef)
End if 

$0:=$cmdStatus
