//%attributes = {}
C_OBJECT:C1216($1;$formControls)
C_OBJECT:C1216($2;$toolbar)
C_OBJECT:C1216($3;$layout)
C_OBJECT:C1216($4;$metrics)
C_OBJECT:C1216($5;$templates)

$formControls:=$1
$toolbar:=$2
$layout:=$3
$metrics:=$4
$templates:=$5

C_COLLECTION:C1488($toolsetRow)
For each ($toolsetRow;$layout.toolsets)
	
	C_OBJECT:C1216($toolsetLayout)
	For each ($toolsetLayout;$toolsetRow)
		
		C_OBJECT:C1216($toolsetControl)
		$toolsetControl:=OB Copy:C1225($templates["toolset"])
		
		$toolsetControl.left:=$layout.bounds.x+$toolsetLayout.bounds.x
		$toolsetControl.top:=$layout.bounds.y+$toolsetLayout.bounds.y
		$toolsetControl.width:=$toolsetLayout.bounds.width
		$toolsetControl.height:=$toolsetLayout.bounds.height
		$toolsetControl.visibility:=Choose:C955($toolbar.visible & $toolsetLayout.toolset.visible;"visible";"hidden")
		
		$formControls[$toolsetLayout.toolset.controlName]:=$toolsetControl
		
		C_OBJECT:C1216($toolLayout)
		For each ($toolLayout;$toolsetLayout.tools)
			
			C_TEXT:C284($commandID)
			$commandID:=$toolLayout.tool.command
			
			C_TEXT:C284($toolType;$toolIcon;$toolTitle)
			$toolType:=$toolLayout.tool.type
			$toolIcon:=$toolLayout.tool.icon
			$toolTitle:=$toolLayout.tool.title
			
			C_OBJECT:C1216($toolControl)
			Case of 
				: ($toolType="button")
					$toolControl:=OB Copy:C1225($templates["tool_button"])
				: ($toolType="radio")
					$toolControl:=OB Copy:C1225($templates["tool_radio"])
				: ($toolType="check")
					$toolControl:=OB Copy:C1225($templates["tool_check"])
				: ($toolType="input")
					
					C_TEXT:C284($valueType)
					$valueType:=$toolLayout.tool.input.valueType
					
					Case of 
						: ($valueType="integer")
							$toolControl:=OB Copy:C1225($templates["tool_integer"])
						: ($valueType="number")
							$toolControl:=OB Copy:C1225($templates["tool_number"])
						: ($valueType="percent")
							$toolControl:=OB Copy:C1225($templates["tool_percent"])
					End case 
					
			End case 
			
			$toolControl.left:=$layout.bounds.x+$toolLayout.bounds.x
			$toolControl.top:=$layout.bounds.y+$toolLayout.bounds.y
			$toolControl.width:=$toolLayout.bounds.width
			$toolControl.height:=$toolLayout.bounds.height
			$toolControl.method:="ToolbarNG_ToolEvent"
			$toolControl.visibility:=Choose:C955($toolbar.visible & $toolsetLayout.toolset.visible;"visible";"hidden")
			
			If ($toolIcon#"")
				$toolControl.icon:=$toolIcon
			End if 
			
			If ($toolTitle#"")
				$toolControl.tooltip:=$toolTitle
			End if 
			
			If (($toolType="radio") | ($toolType="check") | ($toolType="input"))
				
				$toolControl.dataSource:="Form:C1466.controlValues."+$toolLayout.tool.controlName
				
			End if 
			
			$formControls[$toolLayout.tool.controlName]:=$toolControl
			
		End for each 
		
	End for each 
	
End for each 

  // Toolbar separator

C_OBJECT:C1216($toolbarSepControl)
$toolbarSepControl:=OB Copy:C1225($templates["toolbar_sep"])

$toolbarSepControl.left:=$layout.bounds.x
$toolbarSepControl.top:=$layout.bounds.y+$layout.bounds.height-1
$toolbarSepControl.width:=$layout.bounds.width
$toolbarSepControl.visibility:=Choose:C955($toolbar.visible;"visible";"hidden")

$formControls["toolbar_sep"]:=$toolbarSepControl

