//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$context)
C_LONGINT:C283($0;$menubarHeight)

$context:=$1
$menubarHeight:=0

ASSERT:C1129(OB Is defined:C1231($context))

C_OBJECT:C1216($containerSize)
$containerSize:=FormObj_GetSubformContainerSize 

C_LONGINT:C283($containerWidth)
$containerWidth:=SizeObj_GetWidth ($containerSize)

OBJECT SET VISIBLE:C603(*;"menu_@";False:C215)

  //==============================================
  // Menubar layout
  //==============================================

C_LONGINT:C283($titleMarginHorz)
$titleMarginHorz:=OB Get:C1224(<>gImgWSettings;"menu_title_margin_horz";Is longint:K8:6)

C_OBJECT:C1216($masterMenuRect;$masterMenuOrigin;$masterMenuSize)
$masterMenuRect:=FormObj_GetRect ("master_menu")

C_LONGINT:C283($masterMenuHeight)
$masterMenuHeight:=RectObj_GetHeight ($masterMenuRect)

C_OBJECT:C1216($menubar)
$menubar:=OB Get:C1224($context;"_menubar";Is object:K8:27)

ARRAY TEXT:C222($menuObjectNames;0)
OB GET PROPERTY NAMES:C1232($menubar;$menuObjectNames)
SORT ARRAY:C229($menuObjectNames)

C_LONGINT:C283($menuCount)
$menuCount:=Size of array:C274($menuObjectNames)

C_LONGINT:C283($horzMenuSpacing;$vertMenuSpacing)
$horzMenuSpacing:=RectObj_GetX ($masterMenuRect)
$vertMenuSpacing:=RectObj_GetY ($masterMenuRect)

C_LONGINT:C283($curLeft;$curTop)
$curLeft:=$horzMenuSpacing
$curTop:=$vertMenuSpacing

C_LONGINT:C283($visibleMenuCount)
$visibleMenuCount:=0

C_LONGINT:C283($idx)

For ($idx;1;$menuCount)
	
	C_TEXT:C284($objectName)
	$objectName:=$menuObjectNames{$idx}
	
	C_LONGINT:C283($bestWidth)
	$bestWidth:=SizeObj_GetWidth (FormObj_GetBestSize ($objectName))
	
	C_LONGINT:C283($buttonWidth)
	$buttonWidth:=$titleMarginHorz+$bestWidth+$titleMarginHorz
	
	If (($curLeft+$buttonWidth)<=$containerWidth)
		
		C_OBJECT:C1216($objectRect)
		$objectRect:=RectObj_New ($curLeft;$curTop;$buttonWidth;$masterMenuHeight)
		FormObj_SetRect ($objectName;$objectRect)
		
		OBJECT SET VISIBLE:C603(*;$objectName;True:C214)
		
		$visibleMenuCount:=$visibleMenuCount+1
		
	Else 
		OBJECT SET VISIBLE:C603(*;$objectName;False:C215)
	End if 
	
	$curLeft:=$curLeft+$buttonWidth+$horzMenuSpacing
	
End for 

If ($visibleMenuCount>0)
	$menubarHeight:=$vertMenuSpacing+$masterMenuHeight+$vertMenuSpacing
End if 

$0:=$menubarHeight
