//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$configObj)
C_OBJECT:C1216($2;$cmdRegistry)
C_OBJECT:C1216($0;$menubarObj)

ASSERT:C1129(Count parameters:C259=2)

$configObj:=$1
$cmdRegistry:=$2

ARRAY OBJECT:C1221($menubarSpecs;0)
OB GET ARRAY:C1229($configObj;"Menubar";$menubarSpecs)

C_LONGINT:C283($menuCount)
$menuCount:=Size of array:C274($menubarSpecs)

C_LONGINT:C283($idx)

For ($idx;1;$menuCount)
	
	C_OBJECT:C1216($menuSpec)
	$menuSpec:=$menubarSpecs{$idx}
	
	C_TEXT:C284($buttonName;$buttonTitle)
	$buttonName:="menu_"+String:C10($idx;"0000")
	$buttonTitle:=OB Get:C1224($menuSpec;"Title";Is text:K8:3)
	
	If ($buttonTitle#"")
		
		C_OBJECT:C1216($specCopy)
		$specCopy:=OB Copy:C1225($menuSpec)
		
		OB SET:C1220($menubarObj;$buttonName;$specCopy)
		
		C_TEXT:C284($menuHandler)
		$menuHandler:=OB Get:C1224($menuSpec;"Handler";Is text:K8:3)
		
		  // Register commands
		ARRAY OBJECT:C1221($menuItems;0)
		OB GET ARRAY:C1229($menuSpec;"Items";$menuItems)
		
		C_LONGINT:C283($itemIdx)
		
		For ($itemIdx;1;Size of array:C274($menuItems))
			
			C_OBJECT:C1216($itemSpec)
			$itemSpec:=$menuItems{$itemIdx}
			
			Menubar_RegisterItemCmd ($cmdRegistry;$itemSpec;$menuHandler)
			
		End for 
		
	End if 
	
End for 

$0:=$menubarObj
