//%attributes = {}
C_LONGINT:C283($cellWidth;$cellHeight)
$cellWidth:=130
$cellHeight:=154

C_TEXT:C284($thumbFormat)
$thumbFormat:="JPEG"

C_OBJECT:C1216($template)
$template:=SidebarNG_Thumb_CreateTemplate ($cellWidth;$cellHeight;ImgCtlNG_GetMetrics ())

C_TEXT:C284($svgSource)
$svgSource:=$template.svgSource

SET TEXT TO PASTEBOARD:C523($svgSource)

C_TEXT:C284($svgRef)
$svgRef:=DOM Parse XML variable:C720($svgSource)

C_TEXT:C284($outlineElem;$pictElem;$textElem;$selectionElem)

$outlineElem:=DOM Find XML element by ID:C1010($svgRef;"outline")
$pictElem:=DOM Find XML element by ID:C1010($svgRef;"pict")
$textElem:=DOM Find XML element by ID:C1010($svgRef;"text")
$selectionElem:=DOM Find XML element by ID:C1010($svgRef;"selection")

C_OBJECT:C1216($pictSpace)
$pictSpace:=$template.pictSpace

C_TEXT:C284($imagePath)
$imagePath:="/Users/danis/q2/Q2Pix/Dist/Q2Pix 1.0.2/Images/_Imports/House.jpg"

C_BLOB:C604($thumbData)

C_TEXT:C284($imageDoc)
$imageDoc:=ImgDoc_CreateWithFile ($imagePath)
If ($imageDoc#"")
	
	C_OBJECT:C1216($thumbOptions)
	$thumbOptions:=New object:C1471(\
		"Format";$thumbFormat;\
		"ApplyOrientation";True:C214;\
		"Oriented";True:C214;\
		"MaxPixelSize";New object:C1471(\
		"Width";$pictSpace.width;"Height";$pictSpace.height))
	
	$thumbData:=ImgFrame_CreateThumb ($imageDoc;1;$thumbOptions)
	
	ImgObj_Release:P11667:133 ($imageDoc)
End if 

If (BLOB size:C605($thumbData)>0)
	
	C_TEXT:C284($thumbDoc)
	$thumbDoc:=ImgDoc_CreateWithBLOB (->$thumbData;New object:C1471("Format";$thumbFormat))
	
	C_OBJECT:C1216($thumbSize)
	$thumbSize:=ImgFrame_GetPointSize ($thumbDoc;1;True:C214)
	
	ImgObj_Release:P11667:133 ($thumbDoc)
	
	C_REAL:C285($thumbWidth;$thumbHeight)
	$thumbWidth:=SizeObj_GetWidth ($thumbSize)
	$thumbHeight:=SizeObj_GetHeight ($thumbSize)
	
	C_REAL:C285($thumbX;$thumbY)
	$thumbX:=$pictSpace.x+(($pictSpace.width-$thumbWidth)/2)
	$thumbY:=$pictSpace.y+(($pictSpace.height-$thumbHeight)/2)
	
	C_TEXT:C284($thumbData64)
	$thumbData64:=""
	
	BASE64 ENCODE:C895($thumbData;$thumbData64)
	
	DOM SET XML ATTRIBUTE:C866($pictElem;\
		"x";$thumbX;\
		"y";$thumbY;\
		"width";$thumbWidth;\
		"height";$thumbHeight)
	
	DOM SET XML ATTRIBUTE:C866($pictElem;"xlink:href";"data:;base64,"+$thumbData64)
	
End if 

DOM SET XML ELEMENT VALUE:C868($textElem;"999")

SVGTool_SHOW_IN_VIEWER ($svgRef)

C_TEXT:C284($svgCellSource)
DOM EXPORT TO VAR:C863($svgRef;$svgCellSource)

SET TEXT TO PASTEBOARD:C523($svgCellSource)

C_PICTURE:C286($cellPict)
$cellPict:=SVG_Export_to_picture ($svgRef)

SVG_CLEAR ($svgRef)
