//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$configObj)
C_OBJECT:C1216($2;$cmdRegistry)
C_OBJECT:C1216($0;$toolbarObj)

ASSERT:C1129(Count parameters:C259=2)

$configObj:=$1
$cmdRegistry:=$2

ARRAY OBJECT:C1221($toolSpecs;0)
OB GET ARRAY:C1229($configObj;"Toolbar";$toolSpecs)

C_LONGINT:C283($specCount)
$specCount:=Size of array:C274($toolSpecs)

C_LONGINT:C283($idx)

For ($idx;1;$specCount)
	
	C_OBJECT:C1216($specObj)
	$specObj:=$toolSpecs{$idx}
	
	C_TEXT:C284($toolsetName;$formName)
	$toolsetName:=OB Get:C1224($specObj;"Name";Is text:K8:3)
	$formName:=OB Get:C1224($specObj;"Form";Is text:K8:3)
	
	If (($toolsetName#"") & ($formName#""))
		
		C_OBJECT:C1216($formSize)
		  //$formSize:=Comp_GetFormSize ($formName)
		  //If (Not(OB Is defined($formSize)))
		  //$formSize:=Comp_GetFormSize ($formName;True)
		  //End if 
		$formSize:=OB Get:C1224($specObj;"Size";Is object:K8:27)
		
		If (OB Is defined:C1231($formSize))
			
			C_TEXT:C284($objectName)
			$objectName:="toolset_"+String:C10($idx;"0000")
			
			C_TEXT:C284($formHandler)
			$formHandler:=OB Get:C1224($specObj;"Handler";Is text:K8:3)
			If ($formHandler#"")
				
				C_BOOLEAN:C305($handlerOK)
				$handlerOK:=False:C215
				
				If (Is compiled mode:C492(*))
					$handlerOK:=True:C214
				Else 
					
					If (Comp_MethodExists ($formHandler;True:C214))  // Host database
						
						If (Not:C34(<>gQImageControllerStandalone))
							
							If (METHOD Get attribute:C1169($formHandler;Attribute shared:K72:10;*))
								$handlerOK:=True:C214
							Else 
								
								If (Not:C34(Is compiled mode:C492))
									
									ALERT:C41("ImgCtl error: project method "+String_Quoted ($formHandler)+" which is set as the handler for toolset "+String_Quoted ($toolsetName)+" should have its \"shared by components and host database\" attribute set.")
									TRACE:C157
									
								End if 
								
							End if 
							
						Else 
							$handlerOK:=True:C214
						End if 
						
					Else 
						
						If (Comp_MethodExists ($formHandler;False:C215))  // Component
							
							$handlerOK:=True:C214
							
						Else 
							
							If (Not:C34(Is compiled mode:C492))
								
								ALERT:C41("ImgCtl error: project method "+String_Quoted ($formHandler)+" is set as the handler for toolset "+String_Quoted ($toolsetName)+" but was not found in either the Q2ImgControl component or the host database.")
								TRACE:C157
								
							End if 
							
						End if 
						
					End if 
					
				End if 
				
				If (Not:C34($handlerOK))
					OB REMOVE:C1226($specObj;"Handler")
					$formHandler:=""
				End if 
				
			End if 
			
			C_OBJECT:C1216($controlSpecs)
			$controlSpecs:=OB Get:C1224($specObj;"Controls";Is object:K8:27)
			
			ARRAY TEXT:C222($formControls;0)
			OB GET PROPERTY NAMES:C1232($controlSpecs;$formControls)
			
			C_LONGINT:C283($controlIdx)
			For ($controlIdx;1;Size of array:C274($formControls))
				
				C_TEXT:C284($aControlName)
				$aControlName:=$formControls{$controlIdx}
				
				C_OBJECT:C1216($aControlSpec)
				$aControlSpec:=OB Get:C1224($controlSpecs;$aControlName;Is object:K8:27)
				
				C_TEXT:C284($controlCmd;$controlHandler)
				$controlCmd:=OB Get:C1224($aControlSpec;"Command";Is text:K8:3)
				$controlHandler:=OB Get:C1224($aControlSpec;"Handler";Is text:K8:3)
				$controlHandler:=Choose:C955($controlHandler#"";$controlHandler;$formHandler)
				
				If (($controlCmd#"") & ($controlHandler#""))
					
					Command_Register ($cmdRegistry;$controlCmd;$controlHandler)
					
				End if 
				
			End for 
			
			C_OBJECT:C1216($specCopy)
			$specCopy:=OB Copy:C1225($specObj)
			OB SET:C1220($specCopy;"_form_size";$formSize)
			OB SET:C1220($specCopy;"_visible";True:C214)
			
			OB SET:C1220($toolbarObj;$objectName;$specCopy)
			
		Else 
			
			If (Not:C34(Is compiled mode:C492))
				ALERT:C41("ImgCtl error: form "+String_Quoted ($formName)+" is specified as the form for toolset "+String_Quoted ($toolsetName)+" but was not found in either the Q2ImgCtl component or the host database.")
				TRACE:C157
			End if 
			
		End if 
		
	End if 
	
End for 

$0:=$toolbarObj
