//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$context)
C_TEXT:C284($2;$name)

$context:=$1
$name:=$2

ASSERT:C1129(OB Is defined:C1231($context))
ASSERT:C1129($name#"")

C_OBJECT:C1216($toolbar)
$toolbar:=OB Get:C1224($context;"_toolbar";Is object:K8:27)

C_OBJECT:C1216($toolsetSpec)
$toolsetSpec:=OB Get:C1224($toolbar;$name)

If (OB Is defined:C1231($toolsetSpec))
	
	C_TEXT:C284($formName)
	$formName:=OB Get:C1224($toolsetSpec;"Form";Is text:K8:3)
	
	C_OBJECT:C1216($controlSpecs)
	$controlSpecs:=OB Get:C1224($toolsetSpec;"Controls";Is object:K8:27)
	
	ARRAY TEXT:C222($formControls;0)
	OB GET PROPERTY NAMES:C1232($controlSpecs;$formControls)
	
	C_LONGINT:C283($idx)
	
	For ($idx;1;Size of array:C274($formControls))
		
		C_TEXT:C284($aControlName)
		$aControlName:=$formControls{$idx}
		
		C_OBJECT:C1216($aControlSpec)
		$aControlSpec:=OB Get:C1224($controlSpecs;$aControlName;Is object:K8:27)
		
		C_TEXT:C284($command)
		$command:=OB Get:C1224($aControlSpec;"Command";Is text:K8:3)
		
		C_LONGINT:C283($cmdStatus)
		$cmdStatus:=Command_Status ($context;$command)
		
		If (OBJECT Get type:C1300(*;$aControlName)=Object type text input:K79:4)
			OBJECT SET ENTERABLE:C238(*;$aControlName;($cmdStatus & 0x0001)#0)
		Else 
			OBJECT SET ENABLED:C1123(*;$aControlName;($cmdStatus & 0x0001)#0)
		End if 
		
		C_TEXT:C284($controlHelp)
		$controlHelp:=OB Get:C1224($aControlSpec;"Help";Is text:K8:3)
		If ($controlHelp#"")
			OBJECT SET HELP TIP:C1181(*;$aControlName;$controlHelp)
		End if 
		
		C_POINTER:C301($controlPtr)
		$controlPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$aControlName)
		
		C_LONGINT:C283($valueType)
		$valueType:=Type:C295($controlPtr->)
		
		Case of 
			: (($valueType=Is longint:K8:6) | ($valueType=Is real:K8:4))
				
				$controlPtr->:=Num:C11(($cmdStatus & 0x0002)#0)
				
			: ($valueType=Is boolean:K8:9)
				
				$controlPtr->:=($cmdStatus & 0x0002)#0
				
		End case 
		
	End for 
	
	C_TEXT:C284($formHandler)
	$formHandler:=OB Get:C1224($toolsetSpec;"Handler";Is text:K8:3)
	If ($formHandler#"")
		EXECUTE METHOD:C1007($formHandler;*;$context;"update";"")
	End if 
	
End if 

