Class constructor($controlName : Text; $areaName : Text; $handlerMethod : Text)
	
	var $controlPtr; $areaPtr : Pointer
	$controlPtr:=OBJECT Get pointer:C1124(Object named:K67:5; $controlName)
	$areaPtr:=OBJECT Get pointer:C1124(Object named:K67:5; $areaName)
	
	This:C1470.controlName:=""
	This:C1470.areaName:=""
	This:C1470.areaRef:=0
	This:C1470.windowRef:=Current form window:C827
	This:C1470.formName:=Current form name:C1298
	This:C1470.processID:=Process_GetID()
	
	This:C1470.formPage:=-1
	This:C1470.initiallyVisible:=False:C215
	This:C1470.formStorageKey:="formObjectPages#"+String:C10(This:C1470.windowRef)+"#"+String:C10(This:C1470.processID)
	
	This:C1470.messageHandler:=""
	
	This:C1470.metrics:=Null:C1517
	This:C1470.config:=Null:C1517
	
	This:C1470.formControls:=Null:C1517
	This:C1470.layout:=Null:C1517
	This:C1470.form:=Null:C1517
	
	This:C1470.state:=New object:C1471
	This:C1470.state.formSet:=False:C215
	This:C1470.state.layoutUpdated:=False:C215
	This:C1470.state.layoutApplied:=False:C215
	
	This:C1470.controlValues:=Null:C1517
	This:C1470.controlStates:=Null:C1517
	
	
	
	If (Not:C34(Is nil pointer:C315($areaPtr)))
		This:C1470.areaName:=$areaName
		This:C1470.areaRef:=$areaPtr->
	End if 
	
	If (Not:C34(Is nil pointer:C315($controlPtr)))
		
		This:C1470.controlName:=$controlName
		This:C1470.initiallyVisible:=OBJECT Get visible:C1075(*; $controlName)
		
		If (Storage:C1525[This:C1470.formStorageKey]=Null:C1517)
			
			var $formData : Object
			$formData:=New shared object:C1526()
			
			ARRAY TEXT:C222($controlNames; 0)
			ARRAY POINTER:C280($controlVars; 0)
			ARRAY LONGINT:C221($controlPages; 0)
			
			FORM GET OBJECTS:C898($controlNames; $controlVars; $controlPages)
			
			C_LONGINT:C283($idx)
			For ($idx; 1; Size of array:C274($controlNames))
				$formData[$controlNames{$idx}]:=$controlPages{$idx}
			End for 
			
			Use (Storage:C1525)
				
				Storage:C1525[This:C1470.formStorageKey]:=$formData
				
			End use 
			
		End if 
		
		var $controlPage : Integer
		$controlPage:=Storage:C1525[This:C1470.formStorageKey][$controlName]
		
		This:C1470.formPage:=$controlPage
		
		
		var $handlerCallable : Boolean
		$handlerCallable:=False:C215
		
		If (Is compiled mode:C492(*))
			$handlerCallable:=($handlerMethod#"")
		Else 
			If ($handlerMethod#"")
				$handlerCallable:=Comp_CheckCallableMethod($handlerMethod; \
					"which is set as a message handler for Image Controller "+String_Quoted($controlName))
			End if 
		End if 
		If ($handlerCallable)
			This:C1470.messageHandler:=$handlerMethod
		End if 
		
		
		$controlPtr->:=This:C1470
		
		
	End if 
	
	
Function finalize()
	
	If (Storage:C1525[This:C1470.formStorageKey]=Null:C1517)
		Use (Storage:C1525)
			OB REMOVE:C1226(Storage:C1525; This:C1470.formStorageKey)
		End use 
	End if 
	
	
Function _loadConfig()->$config : Object
	
	var $configFile : 4D:C1709.File
	$configFile:=Resource_GetFile("Q2Pix/Q2ImgControl/Configs/"+This:C1470.controlName+".json")
	If ($configFile=Null:C1517)
		$configFile:=Resource_GetFile("Q2Pix/Q2ImgControl/Configs/ImgControl.json")
	End if 
	If ($configFile#Null:C1517)
		File_LoadJSON($configFile; ->$config)
	End if 
	
	
Function setUp($config : Object)->$success : Boolean
	
	$success:=False:C215
	
	If (This:C1470.controlName#Null:C1517)
		
		Case of 
			: ($config=Null:C1517)
				
				$config:=This:C1470._loadConfig()
				
			: (OB Instance of:C1731($config; 4D:C1709.File))
				
				var $localConfig : Object
				If (File_LoadJSON($config; ->$localConfig))
					$config:=$localConfig
				Else 
					$config:=This:C1470._loadConfig()
				End if 
				
		End case 
		
		This:C1470.config:=$config
		
		$success:=True:C214
		
	End if 
	
	