//%attributes = {"shared":true}
C_TEXT:C284($1;$defaultID)  // @param: The ID of the default image source.
C_TEXT:C284($0;$selectedID)  // @param: The ID of the image source selected by the user.

  // @desc: Display the image source selection dialog.

  // @doc: Display the image source selection dialog and return the ID of the source
  // selected by the user.
  //
  // If the user cancels the dialog an empty string is returned.

If (Count parameters:C259>0)
	$defaultID:=$1
End if 

$selectedID:=""

C_TEXT:C284(_pImgSrcSelectedID)
If ($defaultID#"")
	_pImgSrcSelectedID:=$defaultID
End if 

C_LONGINT:C283($window)
$window:=Open form window:C675("_ImgSource";Movable form dialog box:K39:8;Horizontally centered:K39:1;Vertically centered:K39:4)
DIALOG:C40("_ImgSource")
CLOSE WINDOW:C154($window)

$selectedID:=_pImgSrcSelectedID

If ($selectedID="")
	C_OBJECT:C1216($errInfo)
	OB SET:C1220($errInfo;"Domain";"Q2Pix";"Code";kQ2PixErrIntr;\
		"Method";Current method name:C684)
	ImgErr_SetInfo ($errInfo)
End if 

$0:=$selectedID

