//%attributes = {"shared":true}
C_TEXT:C284($0;$errDesc)  // @param: The Q2Pix error description for the current process.

  // @desc: Return the Q2Pix error description for the current process.

  // @doc: Return the Q2Pix error description for the current process.
  //
  // The error description is returned in ``errDesc``.
  //


C_OBJECT:C1216($errInfo)
$errInfo:=ImgErr_GetInfo 
If (OB Is defined:C1231($errInfo))
	If (OB Is defined:C1231($errInfo;"Description"))
		$errDesc:=OB Get:C1224($errInfo;"Description";Is text:K8:3)
	Else 
		$errDesc:=OB Get:C1224($errInfo;"Domain";Is text:K8:3)+" error "+String:C10(OB Get:C1224($errInfo;"Code";Is longint:K8:6))
	End if 
End if 

$0:=$errDesc

