//%attributes = {"shared":true}
C_OBJECT:C1216($1;$pointObj)  // @param: The ``PointObj`` object.
C_REAL:C285($0;$y)  // @param: The Y coordinate of ``pointObj``.

  // @desc: Return the Y coordinate of a PointObj object.

  // @doc: Return the Y coordinate of a ``PointObj`` object.
  //
  // The ``PointObj`` object is passed in the ``pointObj`` parameter.
  //
  // The Y coordinate of ``pointObj`` is returned in ``y``.
  //

ASSERT:C1129(Count parameters:C259=1)

$pointObj:=$1
$y:=0

ASSERT:C1129(OB Is defined:C1231($pointObj;"X"))
ASSERT:C1129(OB Is defined:C1231($pointObj;"Y"))

$y:=OB Get:C1224($pointObj;"Y";Is real:K8:4)

$0:=$y
