//%attributes = {"shared":true}
  // @desc: Initialize the Q2PixLib component.

  // @doc: Must be called from the "On Startup" and "On Server Startup"
  // database methods of the host database.

  // ===========================================================
  // 8 rows of 4 elements describing the transitions from one
  // orientation to another when a rotation or flipping transform
  // is applied to an image.
  // Each row is: {rotate left;rotate right;flip horz;flip vert}

ARRAY LONGINT:C221(<>kImgOrientationTransitions;8;4)

  // 1
<>kImgOrientationTransitions{kImgOrientationNormal}{1}:=kImgRotatedRight
<>kImgOrientationTransitions{kImgOrientationNormal}{2}:=kImgRotatedLeft
<>kImgOrientationTransitions{kImgOrientationNormal}{3}:=kImgFlippedHorz
<>kImgOrientationTransitions{kImgOrientationNormal}{4}:=kImgFlippedVert

  // 2
<>kImgOrientationTransitions{kImgFlippedHorz}{1}:=kImgRotatedLeftFlippedVert
<>kImgOrientationTransitions{kImgFlippedHorz}{2}:=kImgRotatedRightFlippedVert
<>kImgOrientationTransitions{kImgFlippedHorz}{3}:=kImgOrientationNormal
<>kImgOrientationTransitions{kImgFlippedHorz}{4}:=kImgRotated180

  // 3
<>kImgOrientationTransitions{kImgRotated180}{1}:=kImgRotatedLeft
<>kImgOrientationTransitions{kImgRotated180}{2}:=kImgRotatedRight
<>kImgOrientationTransitions{kImgRotated180}{3}:=kImgFlippedVert
<>kImgOrientationTransitions{kImgRotated180}{4}:=kImgFlippedHorz

  // 4
<>kImgOrientationTransitions{kImgFlippedVert}{1}:=kImgRotatedRightFlippedVert
<>kImgOrientationTransitions{kImgFlippedVert}{2}:=kImgRotatedLeftFlippedVert
<>kImgOrientationTransitions{kImgFlippedVert}{3}:=kImgRotated180
<>kImgOrientationTransitions{kImgFlippedVert}{4}:=kImgOrientationNormal

  // 5
<>kImgOrientationTransitions{kImgRotatedLeftFlippedVert}{1}:=kImgFlippedVert
<>kImgOrientationTransitions{kImgRotatedLeftFlippedVert}{2}:=kImgFlippedHorz
<>kImgOrientationTransitions{kImgRotatedLeftFlippedVert}{3}:=kImgRotatedLeft
<>kImgOrientationTransitions{kImgRotatedLeftFlippedVert}{4}:=kImgRotatedRight

  // 6
<>kImgOrientationTransitions{kImgRotatedLeft}{1}:=kImgOrientationNormal
<>kImgOrientationTransitions{kImgRotatedLeft}{2}:=kImgRotated180
<>kImgOrientationTransitions{kImgRotatedLeft}{3}:=kImgRotatedLeftFlippedVert
<>kImgOrientationTransitions{kImgRotatedLeft}{4}:=kImgRotatedRightFlippedVert

  // 7
<>kImgOrientationTransitions{kImgRotatedRightFlippedVert}{1}:=kImgFlippedHorz
<>kImgOrientationTransitions{kImgRotatedRightFlippedVert}{2}:=kImgFlippedVert
<>kImgOrientationTransitions{kImgRotatedRightFlippedVert}{3}:=kImgRotatedRight
<>kImgOrientationTransitions{kImgRotatedRightFlippedVert}{4}:=kImgRotatedLeft

  // 8
<>kImgOrientationTransitions{kImgRotatedRight}{1}:=kImgRotated180
<>kImgOrientationTransitions{kImgRotatedRight}{2}:=kImgOrientationNormal
<>kImgOrientationTransitions{kImgRotatedRight}{3}:=kImgRotatedRightFlippedVert
<>kImgOrientationTransitions{kImgRotatedRight}{4}:=kImgRotatedLeftFlippedVert

