//%attributes = {}
C_TEXT:C284($1; $objectName)
C_LONGINT:C283($2; $event)
C_LONGINT:C283($0; $result)

If (Count parameters:C259>0)
	$objectName:=$1
End if 

If (Count parameters:C259>1)
	$event:=$2
End if 

Case of 
	: ($objectName="")
		
		Case of 
			: ($event=On Load:K2:1)
				
				C_TEXT:C284(_pImgSrcSelectedID)
				
				OBJECT SET TITLE:C194(*; "reload"; "⟳")
				
				_ImgSource_FormHandler("_load_sources")
				_ImgSource_FormHandler("_setup_selection")
				
			: ($event=On Close Box:K2:21)
				
				_pImgSrcSelectedID:=""
				CANCEL:C270
				
		End case 
		
	: ($objectName="source_list")
		
		C_POINTER:C301($sourcePopupPtr)
		$sourcePopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "source_list")
		If ($sourcePopupPtr->>0)
			_pImgSrcSelectedID:=_pImgSrcIDs{$sourcePopupPtr->}
			_ImgSource_FormHandler("_setup_selection")
		End if 
		
	: ($objectName="reload")
		
		_ImgSource_FormHandler("_load_sources")
		_ImgSource_FormHandler("_setup_selection")
		
	: ($objectName="cancel_button")
		
		_pImgSrcSelectedID:=""
		
	: ($objectName="_setup_selection")
		
		C_POINTER:C301($sourcePopupPtr)
		$sourcePopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "source_list")
		
		C_LONGINT:C283($sourceCount; $selectedIdx)
		$sourceCount:=Size of array:C274(_pImgSrcNames)
		$selectedIdx:=0
		If ($sourceCount>0)
			If (_pImgSrcSelectedID#"")
				$selectedIdx:=Find in array:C230(_pImgSrcIDs; _pImgSrcSelectedID)
			End if 
		End if 
		
		If (($sourceCount>0) & ($selectedIdx<=0))
			$selectedIdx:=1
		End if 
		
		$sourcePopupPtr->:=$selectedIdx
		_pImgSrcSelectedID:=_pImgSrcIDs{$selectedIdx}
		
		OBJECT SET ENABLED:C1123(*; "ok_button"; $sourcePopupPtr->>0)
		
		C_POINTER:C301($protocolPtr; $namePtr; $kindPtr; $architecturePtr)
		$protocolPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "protocol")
		$namePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "name")
		$kindPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "kind")
		$architecturePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "architecture")
		
		If ($selectedIdx>0)
			
			C_TEXT:C284($sourceID; $sourceName; $sourceProtocol)
			$sourceID:=_pImgSrcIDs{$selectedIdx}
			
			C_OBJECT:C1216($sourceInfo)
			$sourceInfo:=OB Get:C1224(_pImgSrcList; $sourceID; Is object:K8:27)
			
			$protocolPtr->:=Choose:C955($sourceInfo["Protocol"]#Null:C1517; $sourceInfo["Protocol"]; "")
			$namePtr->:=Choose:C955($sourceInfo["Name"]#Null:C1517; $sourceInfo["Name"]; "")
			$kindPtr->:=Choose:C955($sourceInfo["Kind"]#Null:C1517; $sourceInfo["Kind"]; "")
			
			ARRAY TEXT:C222($archs; 0)
			OB GET ARRAY:C1229($sourceInfo; "Architectures"; $archs)
			
			$architecturePtr->:=Array_Join(->$archs; ", ")
			
		Else 
			$protocolPtr->:=""
			$namePtr->:=""
			$kindPtr->:=""
			$architecturePtr->:=""
		End if 
		
	: ($objectName="_load_sources")
		
		C_OBJECT:C1216(_pImgSrcList)
		_pImgSrcList:=ImgSource_GetList
		
		ARRAY TEXT:C222(_pImgSrcIDs; 0)
		ARRAY TEXT:C222(_pImgSrcNames; 0)
		OB GET PROPERTY NAMES:C1232(_pImgSrcList; _pImgSrcIDs)
		
		C_LONGINT:C283($sourceCount)
		$sourceCount:=Size of array:C274(_pImgSrcIDs)
		
		ARRAY TEXT:C222(_pImgSrcNames; $sourceCount)
		
		C_LONGINT:C283($idx)
		For ($idx; 1; $sourceCount)
			
			C_TEXT:C284($sourceID; $sourceName; $sourceProtocol)
			$sourceID:=_pImgSrcIDs{$idx}
			
			C_OBJECT:C1216($sourceInfo)
			$sourceInfo:=OB Get:C1224(_pImgSrcList; $sourceID; Is object:K8:27)
			
			$sourceName:=Choose:C955($sourceInfo["Name"]#Null:C1517; $sourceInfo["Name"]; "")
			$sourceProtocol:=Choose:C955($sourceInfo["Protocol"]#Null:C1517; $sourceInfo["Protocol"]; "")
			
			If (Find in array:C230(_pImgSrcNames; $sourceName)>0)
				_pImgSrcNames{$idx}:=$sourceName+" ("+$sourceProtocol+")"
			Else 
				_pImgSrcNames{$idx}:=$sourceName
			End if 
			
		End for 
		
		SORT ARRAY:C229(_pImgSrcNames; _pImgSrcIDs; >)
		
		C_POINTER:C301($sourcePopupPtr)
		$sourcePopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "source_list")
		
		COPY ARRAY:C226(_pImgSrcNames; $sourcePopupPtr->)
		
End case 

$0:=$result
