//%attributes = {}
C_OBJECT:C1216($0; $effectDefs)

$effectDefs:=New object:C1471()

C_TEXT:C284($effectJSONPath)
$effectJSONPath:=Get 4D folder:C485(Current resources folder:K5:16)+"EffectDefs-pre.json"

var $effectJSONFile : 4D:C1709.File
$effectJSONFile:=File:C1566($effectJSONPath; fk platform path:K87:2)
If (Not:C34($effectJSONFile.exists))
	$effectJSONPath:=Get 4D folder:C485(Current resources folder:K5:16)+"EffectDefs.json"
	$effectJSONFile:=File:C1566($effectJSONPath; fk platform path:K87:2)
End if 

If ($effectJSONFile.exists)
	
	C_OBJECT:C1216($effectJSONDefs)
	If (File_LoadJSON($effectJSONFile; ->$effectJSONDefs))
		
		If (OB Is defined:C1231($effectJSONDefs; "Common"))
			$effectDefs:=OB_SimpleMerge($effectDefs; OB Get:C1224($effectJSONDefs; "Common"; Is object:K8:27))
		End if 
		
		If (OB Is defined:C1231($effectJSONDefs; "macOS") & Is macOS:C1572)
			$effectDefs:=OB_SimpleMerge($effectDefs; OB Get:C1224($effectJSONDefs; "macOS"; Is object:K8:27))
		End if 
		
		If (OB Is defined:C1231($effectJSONDefs; "Windows") & Is Windows:C1573)
			$effectDefs:=OB_SimpleMerge($effectDefs; OB Get:C1224($effectJSONDefs; "Windows"; Is object:K8:27))
		End if 
		
		If (OB Is defined:C1231($effectJSONDefs; "Windows10") & Is Windows:C1573)
			$effectDefs:=OB_SimpleMerge($effectDefs; OB Get:C1224($effectJSONDefs; "Windows10"; Is object:K8:27))
		End if 
		
	End if 
	
End if 

$0:=$effectDefs
