//%attributes = {}
C_TEXT:C284($1; $objName)
C_LONGINT:C283($2; $event)

$objName:=$1
If (Count parameters:C259>1)
	$event:=$2
End if 

If (True:C214)
	
	C_POINTER:C301($pixelWidthPtr; $pixelHeightPtr)
	$pixelWidthPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "pixel_width")
	$pixelHeightPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "pixel_height")
	
	C_POINTER:C301($pointWidthPtr; $pointHeightPtr)
	$pointWidthPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "point_width")
	$pointHeightPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "point_height")
	
	C_POINTER:C301($percentWidthPtr; $percentHeightPtr)
	$percentWidthPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "percent_width")
	$percentHeightPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "percent_height")
	
	C_POINTER:C301($sizeUnitsPtr)
	$sizeUnitsPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "size_units")
	
	C_POINTER:C301($dpiWidthPtr; $dpiHeightPtr)
	$dpiWidthPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "dpi_width")
	$dpiHeightPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "dpi_height")
	
	C_POINTER:C301($resamplePtr)
	$resamplePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "resample")
	
	C_POINTER:C301($propSizePtr; $propResPtr; $propBothPtr)
	$propSizePtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_size")
	$propResPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_res")
	$propBothPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "prop_both")
	
	C_LONGINT:C283($pixelWidth; $pixelHeight)
	C_REAL:C285($dpiWidth; $dpiHeight)
	C_REAL:C285($pointWidth; $pointHeight)
	C_REAL:C285($percentWidth; $percentHeight)
	
	C_BOOLEAN:C305($propSize; $propRes; $resample)
	
	C_OBJECT:C1216(pImgSizeCtx)
	
	C_OBJECT:C1216($args)
	
End if 

Case of 
	: ($objName="")  // Form method
		
		Case of 
			: ($event=On Load:K2:1)
				
				_RasterSize_Handler("reset")
				_RasterSize_Handler("update_current_size")
				_RasterSize_Handler("update_result_size")
				_RasterSize_Handler("validate_form")
				
			: ($event=On Unload:K2:2)
				
				If (Is a list:C621($sizeUnitsPtr->))
					CLEAR LIST:C377($sizeUnitsPtr->; *)
				End if 
				
		End case 
		
	: ($objName="pixel_width")
		
		If ($event=On After Edit:K2:43)
			$pixelWidth:=Num:C11(Get edited text:C655)
		Else 
			$pixelWidth:=$pixelWidthPtr->
		End if 
		
		$propSize:=($propSizePtr->=1)
		
		If ($pixelWidth>0)
			
			If ($event=On Data Change:K2:15)
				OB SET:C1220(pImgSizeCtx; "pixel_width"; $pixelWidth)
			End if 
			
			If ($propSize)
				
				C_REAL:C285($originalPixelWidth; $originalPixelHeight)
				$originalPixelWidth:=SizeObj_GetWidth(pPixelSize)
				$originalPixelHeight:=SizeObj_GetHeight(pPixelSize)
				
				$pixelHeight:=$originalPixelHeight*($pixelWidth/$originalPixelWidth)
				
				If ($event=On Data Change:K2:15)
					OB SET:C1220(pImgSizeCtx; "pixel_height"; $pixelHeight)
				End if 
				
				$pixelHeightPtr->:=$pixelHeight
				
			End if 
			
			$args:=New object:C1471()
			OB SET:C1220($args; "pixel_width"; $pixelWidth; "pixel_height"; $pixelHeightPtr->)
			OB SET:C1220($args; "dpi_width"; $dpiWidthPtr->; "dpi_height"; $dpiHeightPtr->)
			_RasterSize_Handler("update_result_size"; $args)
			
		End if 
		
		_RasterSize_Handler("validate_form")
		
	: ($objName="pixel_height")
		
		If ($event=On After Edit:K2:43)
			$pixelHeight:=Num:C11(Get edited text:C655)
		Else 
			$pixelHeight:=$pixelHeightPtr->
		End if 
		
		$propSize:=($propSizePtr->=1)
		
		If ($pixelHeight>0)
			
			If ($event=On Data Change:K2:15)
				OB SET:C1220(pImgSizeCtx; "pixel_height"; $pixelHeight)
			End if 
			
			If ($propSize)
				
				C_REAL:C285($originalPixelWidth; $originalPixelHeight)
				$originalPixelWidth:=SizeObj_GetWidth(pPixelSize)
				$originalPixelHeight:=SizeObj_GetHeight(pPixelSize)
				
				$pixelWidth:=$originalPixelWidth*($pixelHeight/$originalPixelHeight)
				
				If ($event=On Data Change:K2:15)
					OB SET:C1220(pImgSizeCtx; "pixel_width"; $pixelWidth)
				End if 
				
				$pixelWidthPtr->:=$pixelWidth
				
			End if 
			
			$args:=New object:C1471()
			OB SET:C1220($args; "pixel_width"; $pixelWidthPtr->; "pixel_height"; $pixelHeight)
			OB SET:C1220($args; "dpi_width"; $dpiWidthPtr->; "dpi_height"; $dpiHeightPtr->)
			_RasterSize_Handler("update_result_size"; $args)
			
		End if 
		
		_RasterSize_Handler("validate_form")
		
	: ($objName="point_width")
		
		If ($event=On After Edit:K2:43)
			$pointWidth:=Num:C11(Get edited text:C655)
		Else 
			$pointWidth:=$pointWidthPtr->
		End if 
		
		$resample:=($resamplePtr->=1)
		
		If ($pointWidth>0)
			
			If ($resample)
				
				$dpiWidth:=OB Get:C1224(pImgSizeCtx; "dpi_width"; Is real:K8:4)
				$dpiHeight:=OB Get:C1224(pImgSizeCtx; "dpi_height"; Is real:K8:4)
				
				$pixelWidth:=($pointWidth*$dpiWidth)/72
				$pixelWidthPtr->:=$pixelWidth
				
				If ($event=On Data Change:K2:15)
					OB SET:C1220(pImgSizeCtx; "pixel_width"; $pixelWidth)
					$pointWidth:=($pixelWidth/$dpiWidth)*72
					$pointWidthPtr->:=$pointWidth
				End if 
				
				$propSize:=($propSizePtr->=1)
				If ($propSize)
					
					C_REAL:C285($originalPixelWidth; $originalPixelHeight)
					$originalPixelWidth:=SizeObj_GetWidth(pPixelSize)
					$originalPixelHeight:=SizeObj_GetHeight(pPixelSize)
					
					$pixelHeight:=$originalPixelHeight*($pixelWidth/$originalPixelWidth)
					
					$pixelHeightPtr->:=$pixelHeight
					$pointHeightPtr->:=($pixelHeight/$dpiHeight)*72
					
					If ($event=On Data Change:K2:15)
						OB SET:C1220(pImgSizeCtx; "pixel_height"; $pixelHeight)
					End if 
					
				End if 
				
				//If ($event=On Data Change)
				//_ImgSize_Call ("update_point_formats")
				//End if 
				
				$args:=New object:C1471()
				OB SET:C1220($args; "pixel_width"; $pixelWidth; "pixel_height"; $pixelHeightPtr->)
				OB SET:C1220($args; "dpi_width"; $dpiWidthPtr->; "dpi_height"; $dpiHeightPtr->)
				_RasterSize_Handler("update_result_size"; $args)
				
			Else 
				
				$pixelWidth:=OB Get:C1224(pImgSizeCtx; "pixel_width"; Is real:K8:4)
				$pixelHeight:=OB Get:C1224(pImgSizeCtx; "pixel_height"; Is real:K8:4)
				
				$dpiWidth:=($pixelWidth*72)/$pointWidth
				$dpiWidthPtr->:=$dpiWidth
				
				If ($event=On Data Change:K2:15)
					OB SET:C1220(pImgSizeCtx; "dpi_width"; $dpiWidth)
					$pointWidthPtr->:=($pixelWidth/$dpiWidth)*72
				End if 
				
				$propRes:=($propResPtr->=1)
				If ($propRes)
					
					C_REAL:C285($originalDPIWidth; $originalDPIHeight)
					$originalDPIWidth:=SizeObj_GetWidth(pDPISize)
					$originalDPIHeight:=SizeObj_GetHeight(pDPISize)
					
					$dpiHeight:=$originalDPIHeight*($dpiWidth/$originalDPIWidth)
					
					If ($event=On Data Change:K2:15)
						OB SET:C1220(pImgSizeCtx; "dpi_height"; $dpiHeight)
					End if 
					
					$dpiHeightPtr->:=$dpiHeight
					$pointHeightPtr->:=($pixelHeight/$dpiHeight)*72
					
				End if 
				
				//If ($event=On Data Change)
				//_ImgSize_Call ("update_point_formats")
				//End if 
				//_ImgSize_Call ("update_res_formats")
				
				$args:=New object:C1471()
				OB SET:C1220($args; "pixel_width"; $pixelWidthPtr->; "pixel_height"; $pixelHeightPtr->)
				OB SET:C1220($args; "dpi_width"; $dpiWidth; "dpi_height"; $dpiHeightPtr->)
				_RasterSize_Handler("update_result_size"; $args)
				
			End if 
			
		End if 
		
		_RasterSize_Handler("validate_form")
		
	: ($objName="point_height")
		
		If ($event=On After Edit:K2:43)
			$pointHeight:=Num:C11(Get edited text:C655)
		Else 
			$pointHeight:=$pointHeightPtr->
		End if 
		
		$resample:=($resamplePtr->=1)
		
		If ($pointHeight>0)
			
			If ($resample)
				
				$dpiWidth:=OB Get:C1224(pImgSizeCtx; "dpi_width"; Is real:K8:4)
				$dpiHeight:=OB Get:C1224(pImgSizeCtx; "dpi_height"; Is real:K8:4)
				
				$pixelHeight:=($pointHeight*$dpiHeight)/72
				$pixelHeightPtr->:=$pixelHeight
				
				If ($event=On Data Change:K2:15)
					OB SET:C1220(pImgSizeCtx; "pixel_height"; $pixelHeight)
					$pointHeight:=($pixelHeight/$dpiHeight)*72
					$pointHeightPtr->:=$pointHeight
				End if 
				
				$propSize:=($propSizePtr->=1)
				If ($propSize)
					
					C_REAL:C285($originalPixelWidth; $originalPixelHeight)
					$originalPixelWidth:=SizeObj_GetWidth(pPixelSize)
					$originalPixelHeight:=SizeObj_GetHeight(pPixelSize)
					
					$pixelWidth:=$originalPixelWidth*($pixelHeight/$originalPixelHeight)
					
					$pixelWidthPtr->:=$pixelWidth
					$pointWidthPtr->:=($pixelWidth/$dpiWidth)*72
					
					If ($event=On Data Change:K2:15)
						OB SET:C1220(pImgSizeCtx; "pixel_width"; $pixelWidth)
					End if 
					
				End if 
				
				//If ($event=On Data Change)
				//_ImgSize_Call ("update_point_formats")
				//End if 
				
				$args:=New object:C1471()
				OB SET:C1220($args; "pixel_width"; $pixelWidthPtr->; "pixel_height"; $pixelHeight)
				OB SET:C1220($args; "dpi_width"; $dpiWidthPtr->; "dpi_height"; $dpiHeightPtr->)
				_RasterSize_Handler("update_result_size"; $args)
				
			Else 
				
				$pixelWidth:=OB Get:C1224(pImgSizeCtx; "pixel_width"; Is real:K8:4)
				$pixelHeight:=OB Get:C1224(pImgSizeCtx; "pixel_height"; Is real:K8:4)
				
				$dpiHeight:=($pixelHeight*72)/$pointHeight
				$dpiHeightPtr->:=$dpiHeight
				
				If ($event=On Data Change:K2:15)
					OB SET:C1220(pImgSizeCtx; "dpi_heighr"; $dpiHeight)
					$pointHeightPtr->:=($pixelHeight/$dpiHeight)*72
				End if 
				
				$propRes:=($propResPtr->=1)
				If ($propRes)
					
					C_REAL:C285($originalDPIWidth; $originalDPIHeight)
					$originalDPIWidth:=SizeObj_GetWidth(pDPISize)
					$originalDPIHeight:=SizeObj_GetHeight(pDPISize)
					
					$dpiWidth:=$originalDPIWidth*($dpiHeight/$originalDPIHeight)
					
					If ($event=On Data Change:K2:15)
						OB SET:C1220(pImgSizeCtx; "dpi_width"; $dpiWidth)
					End if 
					
					$dpiWidthPtr->:=$dpiWidth
					$pointWidthPtr->:=($pixelWidth/$dpiWidth)*72
					
				End if 
				
				//If ($event=On Data Change)
				//_ImgSize_Call ("update_point_formats")
				//End if 
				//_ImgSize_Call ("update_res_formats")
				
				$args:=New object:C1471()
				OB SET:C1220($args; "pixel_width"; $pixelWidthPtr->; "pixel_height"; $pixelHeightPtr->)
				OB SET:C1220($args; "dpi_width"; $dpiWidthPtr->; "dpi_height"; $dpiHeight)
				_RasterSize_Handler("update_result_size"; $args)
				
			End if 
			
		End if 
		
		_RasterSize_Handler("validate_form")
		
	: ($objName="dpi_width")
		
		If ($event=On After Edit:K2:43)
			$dpiWidth:=Num:C11(Get edited text:C655)
		Else 
			$dpiWidth:=$dpiWidthPtr->
		End if 
		
		$resample:=($resamplePtr->=1)
		
		If ($dpiWidth>0)
			
			If (True:C214)  //($resample)
				
				$pixelWidth:=OB Get:C1224(pImgSizeCtx; "pixel_width"; Is real:K8:4)
				$pixelHeight:=OB Get:C1224(pImgSizeCtx; "pixel_height"; Is real:K8:4)
				
				$pointWidth:=($pixelWidth/$dpiWidth)*72
				$pointWidthPtr->:=$pointWidth
				
				If ($event=On Data Change:K2:15)
					OB SET:C1220(pImgSizeCtx; "dpi_width"; $dpiWidth)
				End if 
				
				$propRes:=($propResPtr->=1)
				If ($propRes)
					
					C_REAL:C285($originalDPIWidth; $originalDPIHeight)
					$originalDPIWidth:=SizeObj_GetWidth(pDPISize)
					$originalDPIHeight:=SizeObj_GetHeight(pDPISize)
					
					$dpiHeight:=$originalDPIHeight*($dpiWidth/$originalDPIWidth)
					
					If ($event=On Data Change:K2:15)
						OB SET:C1220(pImgSizeCtx; "dpi_height"; $dpiHeight)
					End if 
					
					$dpiHeightPtr->:=$dpiHeight
					$pointHeightPtr->:=($pixelHeight/$dpiHeight)*72
					
				End if 
				
				//If ($event=On Data Change)
				//_ImgSize_Call ("update_res_formats")
				//End if 
				//_ImgSize_Call ("update_point_formats")
				
				$args:=New object:C1471()
				OB SET:C1220($args; "pixel_width"; $pixelWidthPtr->; "pixel_height"; $pixelHeightPtr->)
				OB SET:C1220($args; "dpi_width"; $dpiWidth; "dpi_height"; $dpiHeightPtr->)
				_RasterSize_Handler("update_result_size"; $args)
				
			Else 
				
				
			End if 
			
		End if 
		
		_RasterSize_Handler("validate_form")
		
	: ($objName="dpi_height")
		
		If ($event=On After Edit:K2:43)
			$dpiHeight:=Num:C11(Get edited text:C655)
		Else 
			$dpiHeight:=$dpiHeightPtr->
		End if 
		
		$resample:=($resamplePtr->=1)
		
		If ($dpiHeight>0)
			
			If (True:C214)  //($resample)
				
				$pixelWidth:=OB Get:C1224(pImgSizeCtx; "pixel_width"; Is real:K8:4)
				$pixelHeight:=OB Get:C1224(pImgSizeCtx; "pixel_height"; Is real:K8:4)
				
				$pointHeight:=($pixelHeight/$dpiHeight)*72
				$pointHeightPtr->:=$pointHeight
				
				If ($event=On Data Change:K2:15)
					OB SET:C1220(pImgSizeCtx; "dpi_height"; $dpiHeight)
				End if 
				
				$propRes:=($propResPtr->=1)
				If ($propRes)
					
					C_REAL:C285($originalDPIWidth; $originalDPIHeight)
					$originalDPIWidth:=SizeObj_GetWidth(pDPISize)
					$originalDPIHeight:=SizeObj_GetHeight(pDPISize)
					
					$dpiWidth:=$originalDPIWidth*($dpiHeight/$originalDPIHeight)
					
					If ($event=On Data Change:K2:15)
						OB SET:C1220(pImgSizeCtx; "dpi_width"; $dpiWidth)
					End if 
					
					$dpiWidthPtr->:=$dpiWidth
					$pointWidthPtr->:=($pixelWidth/$dpiWidth)*72
					
				End if 
				
				//If ($event=On Data Change)
				//_ImgSize_Call ("update_res_formats")
				//End if 
				//_ImgSize_Call ("update_point_formats")
				
				$args:=New object:C1471()
				OB SET:C1220($args; "pixel_width"; $pixelWidthPtr->; "pixel_height"; $pixelHeightPtr->)
				OB SET:C1220($args; "dpi_width"; $dpiWidthPtr->; "dpi_height"; $dpiHeight)
				_RasterSize_Handler("update_result_size"; $args)
				
			Else 
				
				
			End if 
			
		End if 
		
		_RasterSize_Handler("validate_form")
		
	: ($objName="prop_size")
		
		If ($propSizePtr->>1)
			$propSizePtr->:=0
		End if 
		_RasterSize_Handler("update_prop_size_state")
		
		If ($propSizePtr->=1)
			
			// Reset dims
			$pixelWidth:=SizeObj_GetWidth(pPixelSize)
			$pixelHeight:=SizeObj_GetHeight(pPixelSize)
			OB SET:C1220(pImgSizeCtx; "pixel_width"; $pixelWidth)
			OB SET:C1220(pImgSizeCtx; "pixel_height"; $pixelHeight)
			
			_RasterSize_Handler("update_size_values")
			_RasterSize_Handler("update_result_size")
			
		End if 
		
		EDIT ITEM:C870(*; "resample")
		
	: ($objName="prop_res")
		
		If ($propResPtr->>1)
			$propResPtr->:=0
		End if 
		
		_RasterSize_Handler("update_prop_res_state")
		
		If ($propResPtr->=1)
			
			// Reset res
			$dpiWidth:=SizeObj_GetWidth(pDPISize)
			$dpiHeight:=SizeObj_GetHeight(pDPISize)
			OB SET:C1220(pImgSizeCtx; "dpi_width"; $dpiWidth)
			OB SET:C1220(pImgSizeCtx; "dpi_height"; $dpiHeight)
			
			_RasterSize_Handler("update_size_values")
			_RasterSize_Handler("update_res_values")
			_RasterSize_Handler("update_result_size")
			
		End if 
		
		EDIT ITEM:C870(*; "resample")
		
	: ($objName="prop_both")
		
		If ($propBothPtr->>1)
			$propBothPtr->:=0
		End if 
		$propSizePtr->:=$propBothPtr->
		$propResPtr->:=$propBothPtr->
		
		_RasterSize_Handler("update_prop_both_state")
		
		If ($propBothPtr->=1)
			
			// Reset dims
			$pixelWidth:=SizeObj_GetWidth(pPixelSize)
			$pixelHeight:=SizeObj_GetHeight(pPixelSize)
			OB SET:C1220(pImgSizeCtx; "pixel_width"; $pixelWidth)
			OB SET:C1220(pImgSizeCtx; "pixel_height"; $pixelHeight)
			
			// Reset res
			$dpiWidth:=SizeObj_GetWidth(pDPISize)
			$dpiHeight:=SizeObj_GetHeight(pDPISize)
			OB SET:C1220(pImgSizeCtx; "dpi_width"; $dpiWidth)
			OB SET:C1220(pImgSizeCtx; "dpi_height"; $dpiHeight)
			
			_RasterSize_Handler("update_size_values")
			_RasterSize_Handler("update_res_values")
			_RasterSize_Handler("update_result_size")
			
		End if 
		
		EDIT ITEM:C870(*; "resample")
		
	: ($objName="resample")
		
		$resample:=$resamplePtr->=1
		
		If ($resample)
			
			// Reset values
			_RasterSize_Handler("reset")
			_RasterSize_Handler("update_result_size")
			
		Else 
			
			$propSize:=(($propSizePtr-> & 0x0001)#0)
			$propRes:=(($propResPtr-> & 0x0001)#0)
			
			If ($propSize | $propRes)
				$propBothPtr->:=1
			Else 
				$propBothPtr->:=0
			End if 
			
			// Reset dims
			$pixelWidth:=SizeObj_GetWidth(pPixelSize)
			$pixelHeight:=SizeObj_GetHeight(pPixelSize)
			OB SET:C1220(pImgSizeCtx; "pixel_width"; $pixelWidth)
			OB SET:C1220(pImgSizeCtx; "pixel_height"; $pixelHeight)
			
			_RasterSize_Handler("update_resample_state")
			_RasterSize_Handler("update_prop_both_state")
			
			_RasterSize_Handler("update_units_state")
			_RasterSize_Handler("update_size_values")
			_RasterSize_Handler("update_res_values")
			
			_RasterSize_Handler("update_result_size")
			
		End if 
		
	: ($objName="size_units")
		
		_RasterSize_Handler("update_size_values")
		_RasterSize_Handler("update_result_size")
		
	: ($objName="reset_button")
		
		_RasterSize_Handler("reset")
		_RasterSize_Handler("update_result_size")
		EDIT ITEM:C870(*; "resample")
		
	: ($objName="ok_button")
		
		_RasterSize_Handler("store_values")
		
End case 

