//%attributes = {"invisible":true}

<>gXMPLangsByID:=New object:C1471()
<>gXMPLangsByName:=New object:C1471()
<>gXMPLangItemRefsByID:=New object:C1471()

var $resourceFile : 4D:C1709.File
$resourceFile:=Folder:C1567(fk resources folder:K87:11).file("Q2Pix/Q2XMPLib/LanguageIDs.json")

C_OBJECT:C1216($langsDict)
File_LoadJSON($resourceFile; ->$langsDict)

<>gXMPLangIDList:=New list:C375

ARRAY TEXT:C222($langNames; 0)
OB GET PROPERTY NAMES:C1232($langsDict; $langNames)
SORT ARRAY:C229($langNames)

C_LONGINT:C283($itemRef)
C_TEXT:C284($aLangID)

C_LONGINT:C283($ii; $jj)

For ($ii; 1; Size of array:C274($langNames))
	
	C_LONGINT:C283($subList)
	$subList:=New list:C375
	
	C_TEXT:C284($aLangName)
	$aLangName:=$langNames{$ii}
	
	C_OBJECT:C1216($aLangDict)
	$aLangDict:=OB Get:C1224($langsDict; $aLangName; Is object:K8:27)
	
	ARRAY TEXT:C222($countryNames; 0)
	OB GET PROPERTY NAMES:C1232($aLangDict; $countryNames)
	SORT ARRAY:C229($countryNames)
	
	For ($jj; 1; Size of array:C274($countryNames))
		
		C_TEXT:C284($aCountryName)
		$aCountryName:=$countryNames{$jj}
		
		C_TEXT:C284($aLangCountryID)
		$aLangCountryID:=OB Get:C1224($aLangDict; $aCountryName; Is text:K8:3)
		
		C_TEXT:C284($langCountry)
		$langCountry:=$aLangName+"/"+$aCountryName
		
		$itemRef:=($ii << 16) | $jj
		
		APPEND TO LIST:C376($subList; $langCountry; $itemRef)
		SET LIST ITEM PARAMETER:C986($subList; $itemRef; "lang_id"; $aLangCountryID)
		
		OB SET:C1220(<>gXMPLangsByID; $aLangCountryID; $langCountry)
		OB SET:C1220(<>gXMPLangsByName; $langCountry; $aLangCountryID)
		OB SET:C1220(<>gXMPLangItemRefsByID; $aLangCountryID; $itemRef)
		
		If ($jj=1)
			$aLangID:=Substring:C12($aLangCountryID; 1; 2)
		End if 
		
	End for 
	
	$itemRef:=($ii << 16)
	APPEND TO LIST:C376(<>gXMPLangIDList; $aLangName; ($ii << 16); $subList; False:C215)
	SET LIST ITEM PARAMETER:C986(<>gXMPLangIDList; $itemRef; "lang_id"; $aLangID)
	
	OB SET:C1220(<>gXMPLangsByID; $aLangID; $aLangName)
	OB SET:C1220(<>gXMPLangsByName; $aLangName; $aLangID)
	OB SET:C1220(<>gXMPLangItemRefsByID; $aLangID; $itemRef)
	
End for 

//===================================
// Languages popup menu stuff

ARRAY TEXT:C222(<>gXMPRecentLangIDs; 0)
ARRAY TEXT:C222(<>gXMPDefaultLangIDs; 0)

APPEND TO ARRAY:C911(<>gXMPDefaultLangIDs; "en-US")
APPEND TO ARRAY:C911(<>gXMPDefaultLangIDs; "en-GB")
APPEND TO ARRAY:C911(<>gXMPDefaultLangIDs; "en-AU")
APPEND TO ARRAY:C911(<>gXMPDefaultLangIDs; "fr-FR")
APPEND TO ARRAY:C911(<>gXMPDefaultLangIDs; "fr-CA")
APPEND TO ARRAY:C911(<>gXMPDefaultLangIDs; "de-DE")
APPEND TO ARRAY:C911(<>gXMPDefaultLangIDs; "de-AT")
APPEND TO ARRAY:C911(<>gXMPDefaultLangIDs; "de-CH")
