//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$paneContext)
C_TEXT:C284($2;$propName)
C_OBJECT:C1216($3;$propSpec)

$paneContext:=$1
$propName:=$2
$propSpec:=$3

C_BOOLEAN:C305($isEditable)
$isEditable:=Pane_IsPropertyEditable ($paneContext;$propName;$propSpec)

Pane_BuildLabel ($propName;$propSpec)

C_BOOLEAN:C305($isOpen)
$isOpen:=OB Get:C1224($propSpec;"Open";Is boolean:K8:9)

C_BOOLEAN:C305($hasChoices)
$hasChoices:=OB Is defined:C1231($propSpec;"Choices")

C_TEXT:C284($type)
$type:=OB Get:C1224($propSpec;"Type";Is text:K8:3)

If ($isEditable)
	
	If ($hasChoices)
		
		If ($isOpen)
			
			Pane_BuildSimpleCombo ($propName;$propSpec)
			
		Else 
			
			Pane_BuildSimplePopup ($propName;$propSpec)
			
		End if 
		
	Else 
		
		  //_XMPPane_Build_Simple_Entry ($propName;$propSpec;$value;True)
		Pane_BuildSimpleEntry ($propName;$propSpec;True:C214)
		
	End if 
	
Else 
	
	  //_XMPPane_Build_Simple_Entry ($propName;$propSpec;$value;False)
	Pane_BuildSimpleEntry ($propName;$propSpec;False:C215)
	
End if 

Simple_Load ($paneContext;$propName;$propSpec)

