//%attributes = {"invisible":true}
C_TEXT:C284($1;$specType)
C_TEXT:C284($2;$value)
C_BOOLEAN:C305($0;$isValid)

$specType:=$1
$value:=$2
$isValid:=False:C215

Case of 
	: ($specType="")
		
		$isValid:=True:C214
		
	: ($specType="Text")
		
		$isValid:=True:C214
		
	: ($specType="String")
		
		$isValid:=True:C214
		
	: ($specType="Integer")
		
		$isValid:=Match regex:C1019("^([-+]?[1-9]\\d*)|0$";$value;1;*)
		
	: ($specType="Real")
		
		  // http://stackoverflow.com/questions/2811031/decimal-or-numeric-values-in-regular-expression-validation
		$isValid:=Match regex:C1019("^[-+]?(0|[1-9]\\d*)?(\\.\\d+)?(?<=\\d)$";$value;1;*)
		
	: ($specType="Boolean")
		
		$isValid:=Match regex:C1019("^True|False$";$value;1;*)
		
	: ($specType="Rational")
		
		$isValid:=Match regex:C1019("^(([-+]?[1-9]\\d*)|0)/[1-9]\\d*$";$value;1;*)
		
	: ($specType="Date")
		
		$isValid:=Match regex:C1019("^\\d{4}(?:-\\d{2}(?:-\\d{2}(?:T\\d{2}:\\d{2}(?::\\d{2})?(?:[.]\\d)?((?:[-+]\\d{2}:\\d{2})|Z)?)?)?)?$";$value;1;*)
		
	: ($specType="Time")
		
	: ($specType="ProperName")
		
	: ($specType="AgentName")
		
	: ($specType="MIMEType")
		
		$isValid:=Match regex:C1019("^[a-z][-a-z0-9]*/[a-z0-9][-+.a-z0-9]*$";$value;1;*)
		
	: ($specType="URL")
		
	: ($specType="URI")
		
	: ($specType="GUID")
		
	: ($specType="XPath")
		
	: ($specType="DelimitedText")
		
	: ($specType="FrameRate")
		
	: ($specType="FrameCount")
		
	: ($specType="GPSCoordinate")
		
	: ($specType="RenditionClass")
		
End case 


$0:=$isValid
