//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$paneContext)
C_TEXT:C284($2;$propName)
C_LONGINT:C283($3;$event)

$paneContext:=$1
$propName:=$2
$event:=$3

Case of 
	: ($propName="@_add")
		
		$propName:=Substring:C12($propName;1;Length:C16($propName)-Length:C16("_add"))
		
		C_LONGINT:C283($rowCount;$rowIdx)
		$rowCount:=LISTBOX Get number of rows:C915(*;$propName)
		$rowIdx:=$rowCount+1
		
		LISTBOX INSERT ROWS:C913(*;$propName;$rowIdx;1)
		
		LISTBOX SELECT ROW:C912(*;$propName;$rowIdx;lk replace selection:K53:1)
		OBJECT SET SCROLL POSITION:C906(*;$propName;$rowIdx;2)
		EDIT ITEM:C870(*;$propName+"_value";$rowIdx)
		
	: ($propName="@_del")
		
		$propName:=Substring:C12($propName;1;Length:C16($propName)-Length:C16("_del"))
		
		C_LONGINT:C283($selectedRow)
		$selectedRow:=ListBox_GetSelection ($propName)
		
		If ($selectedRow>0)
			
			C_OBJECT:C1216($propSpec)
			$propSpec:=Pane_GetPropSpec ($paneContext;$propName)
			
			LISTBOX DELETE ROWS:C914(*;$propName;$selectedRow)
			
			Seq_Store ($paneContext;$propName;$propSpec)
			
			Seq_Load ($paneContext;$propName;$propSpec)
			
			OBJECT SET ENABLED:C1123(*;$propName+"_del";False:C215)
			
		End if 
		
	Else   // Listbox
		
		Case of 
			: ($event=On Selection Change:K2:29)
				
				If (OBJECT Get type:C1300(*;$propName+"_del")#Object type unknown:K79:1)  // Has add/del buttons
					
					C_LONGINT:C283($selectedRow)
					$selectedRow:=ListBox_GetSelection ($propName)
					
					OBJECT SET ENABLED:C1123(*;$propName+"_del";$selectedRow>0)
				End if 
				
			: ($event=On Losing Focus:K2:8)
				
				LISTBOX SELECT ROW:C912(*;$propName;0;lk remove from selection:K53:3)
				If (OBJECT Get type:C1300(*;$propName+"_del")#Object type unknown:K79:1)  // Has add/del buttons
					OBJECT SET ENABLED:C1123(*;$propName+"_del";False:C215)
				End if 
				
			: ($event=On Before Data Entry:K2:39)
				
				If (OBJECT Get type:C1300(*;$propName+"_del")#Object type unknown:K79:1)  // Has add/del buttons
					OBJECT SET ENABLED:C1123(*;$propName+"_del";False:C215)
				End if 
				
			: ($event=On Delete Action:K2:56)
				
				If (OBJECT Get type:C1300(*;$propName+"_del")#Object type unknown:K79:1)  // Has add/del buttons
					Seq_Event ($paneContext;$propName+"_del";On Clicked:K2:4)
				End if 
				
			: ($event=On Data Change:K2:15)
				
				C_OBJECT:C1216($propSpec)
				$propSpec:=Pane_GetPropSpec ($paneContext;$propName)
				
				C_LONGINT:C283($col;$row)
				LISTBOX GET CELL POSITION:C971(*;$propName;$col;$row)
				
				If ($row>0)
					
					C_POINTER:C301($valuesPtr;$backupsPtr)
					$valuesPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$propName+"_value")
					$backupsPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$propName+"_backup")
					
					$backupsPtr->{$row}:=$valuesPtr->{$row}
					
					C_TEXT:C284($propType)
					$propType:=OB Get:C1224($propSpec;"Type";Is text:K8:3)
					If ($propType="bag")
						SORT ARRAY:C229($valuesPtr->;$backupsPtr->;>)
					End if 
					
				End if 
				
				Seq_Store ($paneContext;$propName;$propSpec)
				
				Seq_Load ($paneContext;$propName;$propSpec)
				
			: ($event=On Row Moved:K2:32)
				
				C_OBJECT:C1216($propSpec)
				$propSpec:=Pane_GetPropSpec ($paneContext;$propName)
				
				Seq_Store ($paneContext;$propName;$propSpec)
				
				Seq_Load ($paneContext;$propName;$propSpec)
				
		End case 
		
End case 

