//%attributes = {"invisible":true}
C_TEXT:C284($1;$propName)  // @param: The property name.
C_TEXT:C284($0;$namePrefix)  // @param: The property name prefix.

  // @desc: Return the property name prefix.

  // @doc: Return the property name prefix.
  //
  // Given a property name in the ``"<prefix>:<name>"`` format in ``propName``,
  // this method returns the ``<prefix>`` part of the property name in ``namePrefix``.
  //

ASSERT:C1129(Count parameters:C259=1)

$propName:=$1
$namePrefix:=""

C_LONGINT:C283($sepPos)
$sepPos:=Position:C15(":";$propName)
If ($sepPos>0)
	$namePrefix:=Substring:C12($propName;1;$sepPos)
End if 

$0:=$namePrefix

