//%attributes = {}
gAcquisitionSourceList:=ImgSource_GetList

ARRAY TEXT:C222(gAcquisitionSourceIDs; 0)
ARRAY TEXT:C222(gAcquisitionSourceNames; 0)
OB GET PROPERTY NAMES:C1232(gAcquisitionSourceList; gAcquisitionSourceIDs)

C_LONGINT:C283($sourceCount)
$sourceCount:=Size of array:C274(gAcquisitionSourceIDs)

ARRAY TEXT:C222(gAcquisitionSourceNames; $sourceCount)

C_LONGINT:C283($idx)
For ($idx; 1; $sourceCount)
	
	C_TEXT:C284($sourceID; $sourceName; $sourceProtocol)
	$sourceID:=gAcquisitionSourceIDs{$idx}
	
	C_OBJECT:C1216($sourceInfo)
	$sourceInfo:=OB Get:C1224(gAcquisitionSourceList; $sourceID; Is object:K8:27)
	
	$sourceName:=OB_GetText($sourceInfo; "Name")
	$sourceProtocol:=OB_GetText($sourceInfo; "Protocol")
	
	If (Find in array:C230(gAcquisitionSourceNames; $sourceName)>0)
		gAcquisitionSourceNames{$idx}:=$sourceName+" ("+$sourceProtocol+")"
	Else 
		gAcquisitionSourceNames{$idx}:=$sourceName
	End if 
	
End for 

SORT ARRAY:C229(gAcquisitionSourceNames; gAcquisitionSourceIDs; >)

C_POINTER:C301($sourcePopupPtr)
$sourcePopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "source_list")

COPY ARRAY:C226(gAcquisitionSourceNames; $sourcePopupPtr->)

