//%attributes = {}
C_TEXT:C284($1; $message)
C_OBJECT:C1216($2; $args)

$message:=""
If (Count parameters:C259>0)
	$message:=$1
End if 
If (Count parameters:C259>1)
	$args:=$2
End if 

C_TEXT:C284(gImageViewerPath)
C_LONGINT:C283(gImageViewerFrame)

Case of 
	: ($message="open") | ($message="")
		
		C_LONGINT:C283(<>gViewerCount)
		<>gViewerCount:=<>gViewerCount+1
		
		C_LONGINT:C283($existingProcess)
		$existingProcess:=0
		
		C_TEXT:C284($imagePath)
		$imagePath:=OB Get:C1224($args; "Path"; Is text:K8:3)
		If ($imagePath#"")
			
			C_LONGINT:C283($processCount; $idx)
			$processCount:=Count tasks:C335
			
			For ($idx; 1; $processCount)
				
				If (Process state:C330($idx)>=Executing:K13:4)
					
					C_TEXT:C284($processName)
					C_LONGINT:C283($processState; $processTime)
					PROCESS PROPERTIES:C336($idx; $processName; $processState; $processTime)
					If ($processName="ImgControl Viewer@")
						
						C_TEXT:C284($processPath)
						GET PROCESS VARIABLE:C371($idx; gImageViewerPath; $processPath)
						If ($processPath=$imagePath)
							$existingProcess:=$idx
							$idx:=$processCount+1
						End if 
						
					End if 
					
				End if 
				
			End for 
			
		End if 
		
		If ($existingProcess#0)
			BRING TO FRONT:C326($existingProcess)
		Else 
			C_LONGINT:C283($newProcess)
			$newProcess:=New process:C317(Current method name:C684; 1024*1024; "ImgControl Viewer "+String:C10(<>gViewerCount); "run"; $args)
		End if 
		
	: ($message="run")
		
		gImageViewerPath:=OB Get:C1224($args; "Path"; Is text:K8:3)
		gImageViewerFrame:=OB Get:C1224($args; "Frame"; Is longint:K8:6)
		
		If (gImageViewerPath="")
			gImageViewerPath:=ImgDlog_PromptOpenFile
		End if 
		
		If (gImageViewerPath#"")
			
			SET MENU BAR:C67(1; *)
			
			C_LONGINT:C283($window)
			$window:=Open form window:C675("ImgCtl_Viewer"; Plain form window:K39:10; *)
			DIALOG:C40("ImgCtl_Viewer")
			CLOSE WINDOW:C154($window)
			
		End if 
		
End case 
