//%attributes = {}
C_TEXT:C284($1; $filePath)
C_LONGINT:C283($0; $imageID)

If (Count parameters:C259>0)
	$filePath:=$1
Else 
	$filePath:=""
End if 

$imageID:=0

C_TEXT:C284($imgDocRef)
$imgDocRef:=ImgDoc_CreateWithFile($filePath)
If ($imgDocRef#"")
	
	$filePath:=ImgDoc_GetFilePath($imgDocRef)
	
	C_PICTURE:C286($thumb)
	$thumb:=ImgFrame_CreateThumbPict($imgDocRef)
	
	ImgObj_Release:P11667:133($imgDocRef)  // No longer needed
	
	C_TEXT:C284($imageName)
	$imageName:=FSRef_GetName(FSRef_SetExtension(FSRef_InitWithPOSIXPath($filePath); ""))
	
	// Copy image to archive?
	C_TEXT:C284($archivePath)
	$archivePath:=Archive_GetDirPath
	
	//If (Substring($filePath;1;Length($archivePath))#$archivePath)
	If ($filePath#($archivePath+"/"+"@"))
		C_TEXT:C284($alert)
		$alert:="Copy image "+String_Quoted($filePath)+" to the archive, or link rerord to original file?\n\n"
		CONFIRM:C162($alert; "Copy"; "Link")
		If (OK=1)
			
			C_TEXT:C284($recordsDirPath)
			$recordsDirPath:=Archive_GetDirPath("_Imports")
			
			$filePath:=Archive_ImportFile($recordsDirPath; $filePath)
			$filePath:=Substring:C12($filePath; Length:C16($archivePath)+2)
			
		End if 
	Else 
		$filePath:=Substring:C12($filePath; Length:C16($archivePath)+2)
	End if 
	
	CREATE RECORD:C68([Image:1])
	[Image:1]Name:2:=$imageName
	[Image:1]Path:3:=$filePath
	[Image:1]Thumb:6:=$thumb
	SAVE RECORD:C53([Image:1])
	
	$imageID:=[Image:1]ID:1
	
	UNLOAD RECORD:C212([Image:1])
	
End if 

$0:=$imageID
