Class constructor($specs : Variant)
	
	var $specsType : Integer
	$specsType:=Value type:C1509($specs)
	
	var $actionSpecs : Object
	
	Case of 
		: ($specsType=Is object:K8:27)
			
			Case of 
				: (OB Instance of:C1731($specs; 4D:C1709.File))
					
					File_LoadJSON($specs; ->$actionSpecs)
					
				: (OB Instance of:C1731($specs; 4D:C1709.Object))
					
					$actionSpecs:=$specs
					
			End case 
			
		: ($specsType=Is text:K8:3)
			
			$actionSpecs:=JSON Parse:C1218($specs; Is object:K8:27)
			
	End case 
	
	// FIXME: Validate against json schema
	
	var $actionName : Text
	For each ($actionName; $actionSpecs.actions)
		
		var $action : cs:C1710.Action
		$action:=cs:C1710.Action.new($actionName; $actionSpecs.actions[$actionName])
		If ($action.validate())
			This:C1470[$actionName]:=$action
		End if 
		
	End for each 
	
	
	