Class constructor($widget : cs:C1710.Widget)
	
	This:C1470.widget:=$widget
	
	This:C1470.pendingBootstrapTimer:=False:C215
	
	
Function _buildForm()->$success : Boolean
	
	$success:=True:C214
	
Function _applyLayout()->$success : Boolean
	
	$success:=True:C214
	
	// ====================================+++=
	// Event handlers
	
Function _handleBootstrap()
	
	var $widget : cs:C1710.Widget
	$widget:=This:C1470.widget
	
	If (Not:C34($widget.state.formBuilt))
		$widget.state.formBuilt:=This:C1470._buildForm()
	End if 
	
	If (Not:C34($widget.state.layoutApplied))
		$widget.state.layoutApplied:=This:C1470._applyLayout()
	End if 
	
	If ($widget.state.pendingVisibility)
		OB_CallForm($widget; $widget._restoreVisibility)
	End if 
	
	
Function _handleUnload()
	
	var $widget : cs:C1710.Widget
	$widget:=This:C1470.widget
	
	$widget.state.formBuilt:=False:C215
	$widget.state.layoutApplied:=False:C215
	
	
Function _handleTimer()->$done : Boolean
	
	If (This:C1470.pendingBootstrapTimer)
		This:C1470.pendingBootstrapTimer:=False:C215
		This:C1470._handleBootstrap()
	End if 
	
	$done:=Not:C34(This:C1470.pendingBootstrapTimer)
	
	
Function _handleFormEvent($event : Object)
	
	Case of 
		: ($event.code=On Load:K2:1)
			
			This:C1470.pendingBootstrapTimer:=True:C214
			SET TIMER:C645(-1)
			
		: ($event.code=On Unload:K2:2)
			
			This:C1470._handleUnload()
			
		: ($event.code=On Resize:K2:27)
			
			//This._handleResize()
			
		: ($event.code=On Timer:K2:25)
			
			var $done : Boolean
			$done:=This:C1470._handleTimer()
			
			If ($done)
				SET TIMER:C645(0)
			End if 
			
		: ($event.code=On Bound Variable Change:K2:52)
			
	End case 
	
	
	