//%attributes = {}
C_VARIANT:C1683($1;$toolConfig)
C_TEXT:C284($2;$controlName)
C_OBJECT:C1216($3;$commands)
C_OBJECT:C1216($0;$newTool)

$toolConfig:=$1
$controlName:=$2
$commands:=$3

Case of 
	: (Value type:C1509($toolConfig)=Is text:K8:3)
		
		C_TEXT:C284($commandName)
		$commandName:=$toolConfig
		
		If ($commandName#"")
			
			C_OBJECT:C1216($toolCommand)
			$toolCommand:=$commands[$commandName]
			
			If ($toolCommand#Null:C1517)
				
				$newTool:=New object:C1471
				
				$newTool.controlName:=$controlName
				$newTool.type:="button"
				$newTool.title:=$toolCommand.title
				If ($newTool.title=Null:C1517)
					$newTool.title:=$commandName
				End if 
				$newTool.icon:=$toolCommand.icon
				$newTool.command:=$commandName
				$newTool.method:=$toolCommand.method
				
			Else 
				
				If (Not:C34(Is compiled mode:C492(*)))
					ALERT:C41("[ImgCtl]\n\nCommand '"+$commandName+"' is not defined.")
					TRACE:C157
				End if 
				
			End if 
			
		End if 
		
	: (Value type:C1509($toolConfig)=Is object:K8:27)
		
		C_OBJECT:C1216($toolConfigObj)
		$toolConfigObj:=$toolConfig
		
		If ($toolConfigObj.command#Null:C1517)
			
			C_OBJECT:C1216($toolCommand)
			$toolCommand:=$commands[$toolConfigObj.command]
			
			If ($toolCommand#Null:C1517)
				
				$newTool:=New object:C1471
				
				$newTool.controlName:=$controlName
				$newTool.type:=Choose:C955($toolConfigObj.type#Null:C1517;$toolConfigObj.type;"button")
				$newTool.title:=$toolConfigObj.title
				If ($newTool.title=Null:C1517)
					$newTool.title:=$toolCommand.title
				End if 
				If ($newTool.title=Null:C1517)
					$newTool.title:=$toolConfigObj.command
				End if 
				$newTool.icon:=$toolConfigObj.icon
				If ($newTool.icon=Null:C1517)
					$newTool.icon:=$toolCommand.icon
				End if 
				
				If ($toolConfigObj.width#Null:C1517)
					$newTool.width:=$toolConfigObj.width
				End if 
				If ($toolConfigObj.height#Null:C1517)
					$newTool.height:=$toolConfigObj.height
				End if 
				
				If ($newTool.type="input")
					
					C_OBJECT:C1216($inputConfig)
					$inputConfig:=$toolConfigObj.input
					
					C_OBJECT:C1216($newInput)
					$newInput:=New object:C1471()
					$newInput.valueType:="integer"
					If ($inputConfig#Null:C1517)
						$newInput.valueType:=Choose:C955($inputConfig.valueType#Null:C1517;$inputConfig.valueType;"integer")
						
						If ($inputConfig.minValue#Null:C1517)
							$newInput.minValue:=$inputConfig.minValue
						End if 
						
						If ($inputConfig.maxValue#Null:C1517)
							$newInput.maxValue:=$inputConfig.maxValue
						End if 
						
					End if 
					
					$newTool.input:=$newInput
					
				End if 
				
				$newTool.command:=$toolConfigObj.command
				$newTool.method:=$toolCommand.method
				
				If (($newTool.type="button") & ($toolConfigObj.items#Null:C1517))
					$newTool.items:=ICNG_Config_Create_ItemList ($toolConfigObj.items;$commands)
				End if 
				
			Else 
				
				If (Not:C34(Is compiled mode:C492(*)))
					ALERT:C41("[ImgCtl]\n\nCommand '"+$toolConfigObj.command+"' is not defined.")
					TRACE:C157
				End if 
				
			End if 
			
		Else 
			
			  //If (Not(Is compiled mode(*)))
			  //ALERT("[ImgCtl]\n\nCommand '"+$commandName+"' which is referenced from menu '"+$menu.title+"' is not defined.")
			  //TRACE
			  //End if 
			
		End if 
		
End case 

$0:=$newTool
