//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.

  // @desc: Pass plug-in area events to a ImgControl form object.

  // @doc: Pass plug-in area events to the ``ImgControl`` form object named ``controlName``.
  //
  // The ``ImgControl`` object has to be notified of plug-in area events coming from the
  // attached plug-in area. This method **must** be called from the object method of the
  // plug-in area during the ``On Plug in Area`` event.

ASSERT:C1129(Count parameters:C259=1)

$controlName:=$1

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	ImgControl_UpdateState ($controlName)
	
End if 
