//%attributes = {}
C_LONGINT:C283($1;$thumbWidth)
C_LONGINT:C283($2;$thumbHeight)
C_OBJECT:C1216($3;$metrics)
C_BOOLEAN:C305($4;$selected)
C_TEXT:C284($5;$caption)
C_PICTURE:C286($6;$pict)
C_PICTURE:C286($0;$thumb)

$thumbWidth:=$1
$thumbHeight:=$2
$metrics:=$3
$selected:=$4
$caption:=$5
If (Count parameters:C259>5)
	$pict:=$6
End if 

C_LONGINT:C283($marginX;$marginY)
$marginX:=$metrics.sidebar.thumb.marginX
$marginY:=$metrics.sidebar.thumb.marginY

C_LONGINT:C283($pictSpaceX;$pictSpaceY)
$pictSpaceX:=$marginX
$pictSpaceY:=$marginY

C_LONGINT:C283($pictSpaceW;$pictSpaceH)
$pictSpaceW:=$thumbWidth-($marginX*2)
$pictSpaceH:=$thumbWidth-($marginY*2)

C_LONGINT:C283($pictSpaceRadX;$pictSpaceRadY)
$pictSpaceRadX:=$marginX*2
$pictSpaceRadY:=$marginY*2

C_TEXT:C284($svgRef;$imageRef;$pictSpaceElem;$textArea;$selRect)

$svgRef:=SVG_New ($thumbWidth;$thumbHeight)

  // Debug
  //$frameRect:=SVG_New_rect ($svgRef;0;0;$thumbWidth;$thumbHeight;0;0;"red";"white:0";1)   \

If (Picture size:C356($pict)>0)
	
	C_LONGINT:C283($pictWidth;$pictHeight)
	PICTURE PROPERTIES:C457($pict;$pictWidth;$pictHeight)
	
	C_OBJECT:C1216($pictRect)
	$pictRect:=RectObj_New (0;0;$pictWidth;$pictHeight)
	
	C_OBJECT:C1216($pictSpace)
	$pictSpace:=RectObj_New ($pictSpaceX;$pictSpaceY;$pictSpaceW;$pictSpaceH)
	
	$pictRect:=RectObj_CenterInRect ($pictRect;$pictSpace)
	$imageRef:=SVG_New_embedded_image ($svgRef;$pict;RectObj_GetX ($pictRect);RectObj_GetY ($pictRect))
	
Else 
	
	$pictSpaceElem:=SVG_New_rect ($svgRef;\
		$pictSpaceX;$pictSpaceY;\
		$pictSpaceW;$pictSpaceH;\
		$pictSpaceRadX;$pictSpaceRadY;\
		$metrics.sidebar.thumb.strokeColor;\
		$metrics.sidebar.thumb.fillColor;\
		$metrics.sidebar.thumb.lineWidth)
	
	SVG_SET_STROKE_DASHARRAY ($pictSpaceElem;$pictSpaceX)
	
	  //End if 
	
End if 

C_LONGINT:C283($textX;$textY)
$textX:=$marginX
$textY:=$marginY+$pictSpaceH+$marginX+1

C_LONGINT:C283($textW;$textH)
$textW:=$pictSpaceW
$textH:=$thumbHeight-$textY

  // Debug
  //$textRect:=SVG_New_rect ($svgRef;$textX;$textY;$textW;$textH;0;0;"green";"white:0";1)   \

$textArea:=SVG_New_textArea ($svgRef;$caption;\
$textX;$textY;$textW;$textH;\
$metrics.sidebar.thumb.font;\
$metrics.sidebar.thumb.textHeight;\
$metrics.sidebar.thumb.style;\
$metrics.sidebar.thumb.textAlignment)

If ($selected)
	
	C_LONGINT:C283($selX;$selY;$selW;$selH)
	$selX:=$metrics.sidebar.selectedThumb.lineWidth/2
	$selY:=$selX
	$selW:=$thumbWidth-($selX*2)
	$selH:=$thumbHeight-($selY*2)
	
	C_LONGINT:C283($selRad)
	$selRad:=$selX*2
	
	$selRect:=SVG_New_rect ($svgRef;\
		$selX;$selY;\
		$selW;$selH;\
		$selRad;$selRad;\
		$metrics.sidebar.selectedThumb.strokeColor;\
		$metrics.sidebar.selectedThumb.fillColor;\
		$metrics.sidebar.selectedThumb.lineWidth)
	
End if 

C_BOOLEAN:C305(<>__inspect_thumb_svg)
If (<>__inspect_thumb_svg)
	SVGTool_SHOW_IN_VIEWER ($svgRef)
End if 

$thumb:=SVG_Export_to_picture ($svgRef)

SVG_CLEAR ($svgRef)

$0:=$thumb
