//%attributes = {}


If (False:C215)
	
	var $style : cs:C1710.Style
	$style:=cs:C1710.Style.new()
	
	var $builder : cs:C1710.ThumbnailBuilder
	$builder:=cs:C1710.ThumbnailBuilder.new($style)
	
	var $cellWidth; $cellHeight : Integer
	$cellWidth:=250
	$cellHeight:=$builder.calcCellHeight($cellWidth)
	
	$builder.setup($cellWidth; $cellHeight)
	
	var $thumb : cs:C1710.Thumbnail
	$thumb:=$builder.createGenericThumb(99; ""; True:C214)
	
	$builder.cleanup()
	
	SET PICTURE TO PASTEBOARD:C521($thumb.pict)
	
End if 

If (False:C215)
	var $targetSize; $sourceSize : cs:C1710.Size
	$targetSize:=cs:C1710.Size.new(300; 300)
	$sourceSize:=cs:C1710.Size.new(100; 200)
	
	var $fitSize : cs:C1710.Rect
	$fitSize:=$targetSize.fit($sourceSize)
	$fitSize:=$sourceSize.fit($targetSize)
	
	
	var $targetRect; $sourceRect : cs:C1710.Rect
	$targetRect:=cs:C1710.Rect.new(0; 0; 300; 300)
	$sourceRect:=cs:C1710.Rect.new(0; 0; 100; 200)
	
	var $fitRect : cs:C1710.Rect
	$fitRect:=$targetRect.fit($sourceRect)
End if 


If (True:C214)
	
	var $style : cs:C1710.Style
	$style:=cs:C1710.Style.new()
	
	var $builder : cs:C1710.ThumbnailBuilder
	$builder:=cs:C1710.ThumbnailBuilder.new($style)
	
	var $cellWidth; $cellHeight : Integer
	$cellWidth:=$style.sidebar.width-$style.scrollbarWidth
	$cellHeight:=$builder.calcCellHeight($cellWidth)
	
	$builder.setup($cellWidth; $cellHeight)
	
	var $maxSize : cs:C1710.Size
	$maxSize:=$builder.maxPictSize()
	
	var $imgPath : Text
	$imgPath:="/Users/danis/Documents/20080621084.jpg"
	
	var $imgDoc : Text
	$imgDoc:=ImgDoc_CreateWithFile($imgPath)
	
	var $sizeOption : Object
	$sizeOption:=New object:C1471()
	$sizeOption["Width"]:=$maxSize.width
	$sizeOption["Height"]:=$maxSize.height
	
	var $options : Object
	$options:=New object:C1471()
	$options["Format"]:="JPEG"
	$options["MaxPixelSize"]:=$sizeOption
	
	var $pictData : Blob
	$pictData:=ImgFrame_CreateThumb($imgDoc; 1; $options)
	
	ImgObj_Release:P11667:133($imgDoc)
	
	var $pict : Picture
	BLOB TO PICTURE:C682($pictData; $pict)
	
	var $thumb : cs:C1710.Thumbnail
	$thumb:=$builder.createThumb(99; ""; $pict; True:C214)
	
	$builder.cleanup()
	
	SET PICTURE TO PASTEBOARD:C521($thumb.pict)
	
End if 

If (False:C215)
	
	var $emptyImgFile : 4D:C1709.File
	$emptyImgFile:=Folder:C1567(fk resources folder:K87:11).folder("Q2Pix").folder("Q2ImgControl").folder("Builtins").file("1x1.png")
	
	var $imgData : Blob
	$imgData:=$emptyImgFile.getContent()
	
	var $base64Data : Text
	
	BASE64 ENCODE:C895($imgData; $base64Data)
	
	SET TEXT TO PASTEBOARD:C523($base64Data)
	
End if 

If (False:C215)
	
	SVG_SET_OPTIONS(SVG_Get_options | 5)
	
	var $svg; $textArea : Text
	$svg:=SVG_New(250; 250)
	$textArea:=SVG_New_textArea($svg; "99"; 50; 50; 100; 22; "Helvetica"; 18; Plain:K14:1; 3)
	
	var $svgSource : Text
	DOM EXPORT TO VAR:C863($svg; $svgSource)
	
	var $dumpFile : 4D:C1709.File
	$dumpFile:=Folder:C1567(fk resources folder:K87:11).folder("Q2Pix").folder("Q2ImgControl").folder("Builtins").file("dump-4d.svg")
	File_StoreText($dumpFile; ->$svgSource)
	
	var $pict : Picture
	SVG EXPORT TO PICTURE:C1017($svg; $pict; Get XML data source:K45:16)
	
	SET PICTURE TO PASTEBOARD:C521($pict)
	
	SVGTool_SHOW_IN_VIEWER($svg)
	
	SVG_CLEAR($svg)
	
End if 
