//%attributes = {}
#DECLARE($text : Text; \
$font : Text; $size : Integer; \
$style : Text; $weight : Text; $decoration : Text)->$textSize : cs:C1710.Size

C_TEXT:C284($svgRef; $textRef)

$svgRef:=DOM Create XML Ref:C861(\
"svg"; "http://www.w3.org/2000/svg"; \
"xmlns:xlink"; "http://www.w3.org/1999/xlink")

$textRef:=DOM Create XML element:C865($svgRef; "textArea"; \
"id"; "text"; \
"visiblility"; "visible"; \
"x"; 0; \
"y"; 0)

DOM SET XML ELEMENT VALUE:C868($textRef; $text)

If ($font#"")
	DOM SET XML ATTRIBUTE:C866($textRef; "font-family"; $font)
End if 

If ($size>0)
	DOM SET XML ATTRIBUTE:C866($textRef; "font-size"; String:C10($size; "&xml"))
End if 

If ($style#"")
	DOM SET XML ATTRIBUTE:C866($textRef; "font-style"; $style)
End if 

If ($weight#"")
	DOM SET XML ATTRIBUTE:C866($textRef; "font-weight"; $weight)
End if 

If ($decoration#"")
	DOM SET XML ATTRIBUTE:C866($textRef; "text-decoration"; $decoration)
End if 

C_PICTURE:C286($pict)
SVG EXPORT TO PICTURE:C1017($svgRef; $pict)

C_LONGINT:C283($width; $height)
PICTURE PROPERTIES:C457($pict; $width; $height)

DOM CLOSE XML:C722($svgRef)

$textSize:=cs:C1710.Size.new($width; $height)

$0:=$textSize
