C_LONGINT:C283($event)
$event:=Form event code:C388

Case of 
	: ($event=On Load:K2:1)
		
		// ==================================
		// Setup format popup
		
		C_TEXT:C284($selectedFormat)
		If (OB Is defined:C1231(Form:C1466.options; "Format"))
			$selectedFormat:=OB Get:C1224(Form:C1466.options; "Format"; Is text:K8:3)
		Else 
			$selectedFormat:=ImgDoc_GetFormat:P11667:9(Form:C1466.docRef)
		End if 
		
		C_LONGINT:C283($selectedIdx)
		$selectedIdx:=Find in array:C230(Form:C1466.formatIDs; $selectedFormat)
		If ($selectedIdx<=0)
			$selectedIdx:=Find in array:C230(Form:C1466.formatIDs; "TIFF")
		End if 
		If ($selectedIdx<=0)
			$selectedIdx:=Find in array:C230(Form:C1466.formatIDs; "JPEG")
		End if 
		If ($selectedIdx<=0)
			$selectedIdx:=1
		End if 
		$selectedFormat:=Form:C1466.formatIDs[$selectedIdx]
		
		Form:C1466.formatPopup:=New object:C1471()
		Form:C1466.formatPopup.values:=Form:C1466.formatNames
		Form:C1466.formatPopup.index:=$selectedIdx-1
		
		// ==================================
		// Setup TIFF popups
		
		Form:C1466.TIFFCodecBWNames:=New collection:C1472(\
			"CCITT Fax 4"; \
			"CCITT Fax 3"; \
			"CCITT RLE"; \
			"None")
		Form:C1466.TIFFCodecBWValues:=New collection:C1472(\
			kTIFFCompressionCCITTFax4; \
			kTIFFCompressionCCITTFax3; \
			kTIFFCompressionCCITTRLE; \
			kTIFFCompressionNone)
		
		Form:C1466.TIFFCodecGrayNames:=New collection:C1472(\
			"LZW"; \
			"Deflate"; \
			"None")
		Form:C1466.TIFFCodecGrayValues:=New collection:C1472(\
			kTIFFCompressionLZW; \
			kTIFFCompressionDeflate; \
			kTIFFCompressionNone)
		
		Form:C1466.TIFFCodecColorNames:=New collection:C1472(\
			"LZW"; \
			"Deflate"; \
			"None")
		Form:C1466.TIFFCodecColorValues:=New collection:C1472(\
			kTIFFCompressionLZW; \
			kTIFFCompressionDeflate; \
			kTIFFCompressionNone)
		
		Form:C1466.TIFFCompressionBWPopup:=New object:C1471()
		Form:C1466.TIFFCompressionBWPopup.values:=Form:C1466.TIFFCodecBWNames
		Form:C1466.TIFFCompressionBWPopup.index:=0
		
		Form:C1466.TIFFCompressionGrayPopup:=New object:C1471()
		Form:C1466.TIFFCompressionGrayPopup.values:=Form:C1466.TIFFCodecGrayNames
		Form:C1466.TIFFCompressionGrayPopup.index:=0
		
		Form:C1466.TIFFCompressionColorPopup:=New object:C1471()
		Form:C1466.TIFFCompressionColorPopup.values:=Form:C1466.TIFFCodecColorNames
		Form:C1466.TIFFCompressionColorPopup.index:=0
		
		// ==================================
		// Setup options
		
		If (OB Is defined:C1231(Form:C1466.options; "TIFFMonochromeEncoding"))
			Form:C1466.TIFFCompressionBWPopup.index:=Form:C1466.TIFFCompressionBWPopup.values.indexOf(\
				OB Get:C1224(Form:C1466.options; "TIFFMonochromeEncoding"; Is longint:K8:6))
		End if 
		Form:C1466.TIFFCompressionBWPopup.index:=Choose:C955(\
			Form:C1466.TIFFCompressionBWPopup.index>=0; Form:C1466.TIFFCompressionBWPopup.index; 0)
		
		If (OB Is defined:C1231(Form:C1466.options; "TIFFGrayscaleEncoding"))
			Form:C1466.TIFFCompressionGrayPopup.index:=Form:C1466.TIFFCompressionGrayPopup.values.indexOf(\
				OB Get:C1224(Form:C1466.options; "TIFFGrayscaleEncoding"; Is longint:K8:6))
		End if 
		Form:C1466.TIFFCompressionGrayPopup.index:=Choose:C955(\
			Form:C1466.TIFFCompressionGrayPopup.index>=0; Form:C1466.TIFFCompressionGrayPopup.index; 0)
		
		If (OB Is defined:C1231(Form:C1466.options; "TIFFColorEncoding"))
			Form:C1466.TIFFCompressionColorPopup.index:=Form:C1466.TIFFCompressionColorPopup.values.indexOf(\
				OB Get:C1224(Form:C1466.options; "TIFFColorEncoding"; Is longint:K8:6))
		End if 
		Form:C1466.TIFFCompressionColorPopup.index:=Choose:C955(\
			Form:C1466.TIFFCompressionColorPopup.index>=0; Form:C1466.TIFFCompressionColorPopup.index; 0)
		
		If (OB Is defined:C1231(Form:C1466.options; "Recompress"))
			Form:C1466.recompress:=OB Get:C1224(Form:C1466.options; "Recompress"; Is boolean:K8:9)
		Else 
			Form:C1466.recompress:=False:C215
		End if 
		
		If (OB Is defined:C1231(Form:C1466.options; "LossyCompressionQuality"))
			Form:C1466.quality:=OB Get:C1224(Form:C1466.options; "LossyCompressionQuality"; Is real:K8:4)
		Else 
			Form:C1466.quality:=0.75
		End if 
		Form:C1466.displayQuality:=Form:C1466.quality*10
		
		If (OB Is defined:C1231(Form:C1466.options; "EmbedThumbnail"))
			Form:C1466.embedThumb:=OB Get:C1224(Form:C1466.options; "EmbedThumbnail"; Is boolean:K8:9)
		Else 
			Form:C1466.embedThumb:=False:C215
		End if 
		
		// Apply orientation
		
		//Form.applyOrientationGeneric:=True
		//Form.applyOrientationJPEG:=False
		//Form.applyOrientationTIFF:=False
		//Form.applyOrientationJP2:=False
		//Form.applyOrientationPSD:=True
		
		//If (OB Is defined(Form.options; "ApplyOrientation"))
		
		//C_BOOLEAN($applyOrientation)
		//$applyOrientation:=OB Get(Form.options; "ApplyOrientation"; Is boolean)
		
		//Case of 
		//: ($selectedFormat="JPEG")
		//Form.applyOrientationJPEG:=$applyOrientation
		//: ($selectedFormat="TIFF")
		//Form.applyOrientationTIFF:=$applyOrientation
		//: ($selectedFormat="JPEG 2000")
		//Form.applyOrientationJP2:=$applyOrientation
		//: ($selectedFormat="PSD")
		//Form.applyOrientationPSD:=$applyOrientation
		//Else 
		//Form.applyOrientationGeneric:=$applyOrientation
		//End case 
		
		//End if 
		
		If (OB Is defined:C1231(Form:C1466.options; "ApplyOrientation"))
			Form:C1466.applyOrientation:=OB Get:C1224(Form:C1466.options; "ApplyOrientation"; Is boolean:K8:9)
		Else 
			If (($selectedFormat="JPEG") | ($selectedFormat="TIFF")\
				 | ($selectedFormat="JPEG 2000") | ($selectedFormat="PSD"))
				Form:C1466.applyOrientation:=False:C215
			Else 
				Form:C1466.applyOrientation:=True:C214
			End if 
		End if 
		
		// ==================================
		// Adjust options for source format
		
		C_TEXT:C284($docFormat)
		$docFormat:=ImgDoc_GetFormat:P11667:9(Form:C1466.docRef)
		
		C_OBJECT:C1216($docFormatInfo)
		$docFormatInfo:=ImgFormat_GetInfo($docFormat)
		
		C_BOOLEAN:C305($docFormatIsLossy)
		$docFormatIsLossy:=(($docFormat="JPEG") | ($docFormat="JPEG 2000"))
		
		If ($docFormatIsLossy)
			
			C_LONGINT:C283($docMods)
			$docMods:=ImgDoc_GetEditsSummary:P11667:14(Form:C1466.docRef)
			If (($docMods & kRasterFramePixelsModified)#0)
				
				Form:C1466.recompress:=True:C214
				OBJECT SET ENABLED:C1123(*; "@_recompress"; False:C215)
				
			Else 
				
				Form:C1466.recompress:=False:C215
				
			End if 
			
		Else 
			
			Form:C1466.recompress:=True:C214
			OBJECT SET ENABLED:C1123(*; "@_recompress"; False:C215)
			
		End if 
		
		If ($docFormatIsLossy & Form:C1466.applyOrientation)
			Form:C1466.recompress:=True:C214
			OBJECT SET ENABLED:C1123(*; "@_recompress"; False:C215)
		End if 
		
		OBJECT SET ENABLED:C1123(*; "@_quality"; Form:C1466.recompress)
		
		OBJECT SET ENABLED:C1123(*; "tiff_codec_@_popup"; True:C214)
		
		If (Not:C34(Form:C1466.isMultiframe))
			
			C_OBJECT:C1216($frameProps)
			$frameProps:=ImgFrame_GetProperties(Form:C1466.docRef; 1)
			
			If (OB Is defined:C1231($frameProps))
				
				C_TEXT:C284($colorModel)
				$colorModel:=OB Get:C1224($frameProps; "ColorModel"; Is text:K8:3)
				
				Case of 
					: ($colorModel="Gray")
						
						C_LONGINT:C283($bitsPerChannel)
						$bitsPerChannel:=OB Get:C1224($frameProps; "BitsPerChannel"; Is longint:K8:6)
						If ($bitsPerChannel=1)
							
							OBJECT SET ENABLED:C1123(*; "tiff_codec_bw_popup"; True:C214)
							OBJECT SET ENABLED:C1123(*; "tiff_codec_gray_popup"; False:C215)
							OBJECT SET ENABLED:C1123(*; "tiff_codec_color_popup"; False:C215)
							
						Else 
							
							OBJECT SET ENABLED:C1123(*; "tiff_codec_bw_popup"; False:C215)
							OBJECT SET ENABLED:C1123(*; "tiff_codec_gray_popup"; True:C214)
							OBJECT SET ENABLED:C1123(*; "tiff_codec_color_popup"; False:C215)
							
						End if 
						
					Else 
						
						OBJECT SET ENABLED:C1123(*; "tiff_codec_bw_popup"; False:C215)
						OBJECT SET ENABLED:C1123(*; "tiff_codec_gray_popup"; False:C215)
						OBJECT SET ENABLED:C1123(*; "tiff_codec_color_popup"; True:C214)
						
				End case 
				
			End if 
			
		End if 
		
		// ==================================
		
		Case of 
			: ($selectedFormat="JPEG")
				
				FORM GOTO PAGE:C247(2)
				
			: ($selectedFormat="TIFF")
				
				FORM GOTO PAGE:C247(3)
				
			: ($selectedFormat="JPEG 2000")
				
				FORM GOTO PAGE:C247(4)
				
			: ($selectedFormat="PSD")
				
				FORM GOTO PAGE:C247(5)
				
			Else 
				
				FORM GOTO PAGE:C247(1)
				
		End case 
		
End case 
