//%attributes = {"shared":true}
C_OBJECT:C1216($1;$rectObj)  // @param: The ``RectObj`` object.
C_REAL:C285($0;$height)  // @param: The height of ``rectObj``.

  // @desc: Return the height of a RectObj object.

  // @doc: Return the height of a ``RectObj`` object.
  //
  // The ``RectObj`` object is passed in the ``rectObj`` parameter.
  //
  // The height of ``rectObj`` is returned in ``height``.
  //

ASSERT:C1129(Count parameters:C259=1)

$rectObj:=$1
$height:=0

ASSERT:C1129(OB Is defined:C1231($rectObj;"X"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Y"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Width"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Height"))

$height:=OB Get:C1224($rectObj;"Height";Is real:K8:4)

$0:=$height
