//%attributes = {"shared":true}
C_OBJECT:C1216($1;$sizeObj)  // @param: The ``SizeObj`` object.
C_REAL:C285($0;$height)  // @param: The height of ``sizeObj``. 

  // @desc: Return the height of a SizeObj object.

  // @doc: Return the height of a ``SizeObj`` object.
  //
  // The ``SizeObj`` object is passed in the ``sizeObj`` parameter.
  //
  // The height of ``sizeObj`` is returned in ``height``.
  //

ASSERT:C1129(Count parameters:C259=1)

$sizeObj:=$1
$height:=0

ASSERT:C1129(OB Is defined:C1231($sizeObj;"Width"))
ASSERT:C1129(OB Is defined:C1231($sizeObj;"Height"))

$height:=OB Get:C1224($sizeObj;"Height";Is real:K8:4)

$0:=$height
