//%attributes = {}
C_TEXT:C284($1;$objectName)
C_LONGINT:C283($2;$event)

If (Count parameters:C259>0)
	$objectName:=$1
End if 

If (Count parameters:C259>1)
	$event:=$2
End if 

C_POINTER:C301($effectPopupPtr)
$effectPopupPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"effect_popup")

C_LONGINT:C283($effectIdx)
$effectIdx:=$effectPopupPtr->

C_TEXT:C284($effectName)
$effectName:=pEffectNames{$effectIdx}

C_OBJECT:C1216($effectSpec)
$effectSpec:=OB Get:C1224(pDialogEffects;$effectName;Is object:K8:27)

C_OBJECT:C1216($effectParams)
$effectParams:=OB Get:C1224($effectSpec;"Params";Is object:K8:27)

C_OBJECT:C1216($paramValues)
$paramValues:=OB Get:C1224($effectSpec;"ParamValues";Is object:K8:27)

C_LONGINT:C283($effectPage)
$effectPage:=OB Get:C1224($effectSpec;"Page";Is longint:K8:6)

C_OBJECT:C1216($formBindings)
$formBindings:=OB Get:C1224($effectSpec;"Bindings";Is object:K8:27)

ARRAY TEXT:C222($formObjects;0)
OB GET PROPERTY NAMES:C1232($formBindings;$formObjects)

C_LONGINT:C283($idx;$count)
$count:=Size of array:C274($formObjects)

OBJECT SET ENABLED:C1123(*;"reset_button";($count>0))

Case of 
	: ($effectName="Monochrome")
		
		C_POINTER:C301($adaptiveParamPtr;$thresholdParamPtr)
		$adaptiveParamPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"adaptive_param")
		$thresholdParamPtr:=OBJECT Get pointer:C1124(Object named:K67:5;"threshold_param")
		
		Case of 
			: (($objectName="") | ($objectName="adaptive_param"))
				
				OBJECT SET ENABLED:C1123(*;"threshold_param";$adaptiveParamPtr->=0)
				
		End case 
		
		If (($adaptiveParamPtr->=0) & ($thresholdParamPtr->=0))
			
			$adaptiveParamPtr->:=1
			OB SET:C1220($paramValues;"Adaptive";True:C214)
			
			OBJECT SET ENABLED:C1123(*;"threshold_param";False:C215)
			
			C_REAL:C285($realVal)
			$realVal:=OB Get:C1224($paramValues;"Threshold";Is real:K8:4)
			
			C_OBJECT:C1216($objectBinding)
			$objectBinding:=OB Get:C1224($formBindings;"threshold_param";Is object:K8:27)
			
			C_REAL:C285($scale)
			$scale:=OB Get:C1224($objectBinding;"Scale";Is real:K8:4)
			
			C_LONGINT:C283($sliderVal)
			$sliderVal:=$realVal*$scale
			
			$thresholdParamPtr->:=$sliderVal
			
		End if 
		
End case 
