//%attributes = {"shared":true}
C_OBJECT:C1216($1; $dirFSRef)
C_POINTER:C301($2; $itemArrayPtr)
C_OBJECT:C1216($3; $optionsObj)
C_BOOLEAN:C305($0; $success)

$dirFSRef:=$1
$itemArrayPtr:=$2
If (Count parameters:C259>2)
	$optionsObj:=$3
End if 
$success:=False:C215

C_BOOLEAN:C305($incFiles; $incDirs; $incHidden; $recursive)
C_TEXT:C284($nameFilter)

$incFiles:=OB_GetBoolean($optionsObj; "includeFiles"; True:C214)
$incDirs:=OB_GetBoolean($optionsObj; "includeDirs"; False:C215)
$incHidden:=OB_GetBoolean($optionsObj; "includeHidden"; False:C215)
$recursive:=OB_GetBoolean($optionsObj; "recursive"; False:C215)
$nameFilter:=OB_GetText($optionsObj; "filter"; "")

Array_Clear($itemArrayPtr)

If (FSRef_IsDir($dirFSRef))
	C_TEXT:C284($dirPath)
	$dirPath:=OB Get:C1224($dirFSRef; "path"; Is text:K8:3)
	
	ARRAY TEXT:C222($itemPaths; 0)
	
	$success:=FSPath_GetDirItems($dirPath; ->$itemPaths; $incFiles; $incDirs; $incHidden; $recursive; $nameFilter)
	If ($success)
		
		C_LONGINT:C283($itemCount)
		$itemCount:=Size of array:C274($itemPaths)
		
		Case of 
			: (Type:C295($itemArrayPtr->)=Object array:K8:28)
				
				INSERT IN ARRAY:C227($itemArrayPtr->; 1; $itemCount)
				
				C_LONGINT:C283($idx)
				
				For ($idx; 1; $itemCount)
					$itemArrayPtr->{$idx}:=FSRef__InitWithPath($itemPaths{$idx})
				End for 
				
			: (Type:C295($itemArrayPtr->)=Text array:K8:16)
				
				COPY ARRAY:C226($itemPaths; $itemArrayPtr->)
				
		End case 
		
	End if 
	
End if 

$0:=$success
