//%attributes = {"shared":true}
C_TEXT:C284($1; $pattern)
C_TEXT:C284($2; $target)
C_POINTER:C301($3; $segArrayPtr)
//C_BOOLEAN($0;$success)

$pattern:=$1
$target:=$2
$segArrayPtr:=$3
//$success:=False

Array_Clear($segArrayPtr)

C_LONGINT:C283($start; $lastStart)
$start:=1
$lastStart:=1

C_LONGINT:C283($targetLen)
$targetLen:=Length:C16($target)

If ($targetLen>0)
	
	C_LONGINT:C283($segPos; $segLen)
	C_TEXT:C284($aSeg)
	
	C_BOOLEAN:C305($break)
	$break:=False:C215
	
	While (($start<=$targetLen) & Not:C34($break))
		
		ARRAY LONGINT:C221($matchedGroupOffsets; 0)
		ARRAY LONGINT:C221($matchedGroupLengths; 0)
		
		If (Match regex:C1019($pattern; $target; $start; $matchedGroupOffsets; $matchedGroupLengths))
			
			C_LONGINT:C283($matchPos; $matchLen)
			$matchPos:=$matchedGroupOffsets{0}
			$matchLen:=$matchedGroupLengths{0}
			
			$segPos:=$lastStart
			$segLen:=$matchPos-$lastStart
			
			$aSeg:=Substring:C12($target; $segPos; $segLen)
			APPEND TO ARRAY:C911($segArrayPtr->; $aSeg)
			
			$start:=$matchPos+$matchLen
			$lastStart:=$start
			
			If ($matchLen=0)
				// Advance start for zero-length matches, otherwise
				// we'll get into an infinite loop.
				$start:=1
			End if 
			
		Else 
			$aSeg:=Substring:C12($target; $lastStart; $targetLen)
			APPEND TO ARRAY:C911($segArrayPtr->; $aSeg)
			$break:=True:C214
		End if 
		
	End while 
	
	If (Not:C34($break))
		
		// We only get here if the last iteration yielded a match
		// and the match ate up the rest of the string.
		// In that case we add an empty string
		
		APPEND TO ARRAY:C911($segArrayPtr->; "")
		
	End if 
	
	//$success:=True
	
End if 

//$0:=$success

