//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$context)
C_TEXT:C284($2;$parentName)
C_TEXT:C284($3;$propName)
C_OBJECT:C1216($4;$propSpec)

$context:=$1
$parentName:=$2
$propName:=$3
$propSpec:=$4

ASSERT:C1129(OB Is defined:C1231($context))

C_TEXT:C284($xmpDataRef)
$xmpDataRef:=OB Get:C1224($context;"xmp_edit_data";Is text:K8:3)

C_TEXT:C284($fullName)
$fullName:=Choose:C955($parentName#"";$parentName+"/"+$propName;$propName)

C_TEXT:C284($propType)
$propType:=OB Get:C1224($propSpec;"Type";Is text:K8:3)

Case of 
	: ($propType="struct")
		
		If (OB Is defined:C1231($propSpec;"Contents"))
			
			XMPData_CreateProperty:P11667:86 ($xmpDataRef;$fullName;kXMPPropTypeStructure)
			
			C_OBJECT:C1216($subSpecs)
			$subSpecs:=OB Get:C1224($propSpec;"Contents";Is object:K8:27)
			
			ARRAY TEXT:C222($subNames;0)
			OB GET PROPERTY NAMES:C1232($subSpecs;$subNames)
			
			C_LONGINT:C283($idx)
			
			For ($idx;1;Size of array:C274($subNames))
				
				C_TEXT:C284($aName)
				$aName:=$subNames{$idx}
				
				C_OBJECT:C1216($aSpec)
				$aSpec:=OB Get:C1224($subSpecs;$aName;Is object:K8:27)
				
				Editor_CreateProperty ($context;$fullName;$aName;$aSpec)
				
			End for 
			
		End if 
		
	: ($propType="array")
		
		XMPData_CreateProperty:P11667:86 ($xmpDataRef;$fullName;kXMPPropTypeArray)
		
	: ($propType="bag")
		
		XMPData_CreateProperty:P11667:86 ($xmpDataRef;$fullName;kXMPPropTypeBag)
		
	: ($propType="LangAlt")
		
		XMPData_CreateProperty:P11667:86 ($xmpDataRef;$fullName;kXMPPropTypeLangAltArray)
		
	Else 
		
		XMPData_CreateProperty:P11667:86 ($xmpDataRef;$fullName;kXMPPropTypeSimple)
		
End case 
