//%attributes = {"invisible":true}
// =====================================
// Namespace info dictionary
// =====================================

<>gXMPNamespaces:=New object:C1471()

//-------------------------------
// Load namespace specs

//ARRAY OBJECT($nsFSRefs; 0)
//Lib_CollectResourceFSRefs("Q2Pix/Q2XMPLib/Namespaces"; ->$nsFSRefs; "*.json")

var $nsFiles : Collection
$nsFiles:=Lib_CollectResourceFiles("Q2Pix/Q2XMPLib/Namespaces"; ".json")

C_LONGINT:C283($ii; $jj)

For ($ii; 0; $nsFiles.length-1)
	
	C_OBJECT:C1216($json)
	File_LoadJSON($nsFiles[$ii]; ->$json)
	
	If (OB Is defined:C1231($json; "Namespaces"))
		
		C_OBJECT:C1216($specs)
		$specs:=OB Get:C1224($json; "Namespaces"; Is object:K8:27)
		
		ARRAY TEXT:C222($nsURIs; 0)
		OB GET PROPERTY NAMES:C1232($specs; $nsURIs)
		
		For ($jj; 1; Size of array:C274($nsURIs))
			
			C_TEXT:C284($aURI)
			$aURI:=$nsURIs{$jj}
			
			C_OBJECT:C1216($aSpec)
			$aSpec:=OB Get:C1224($specs; $aURI; Is object:K8:27)
			
			OB SET:C1220(<>gXMPNamespaces; $aURI; OB Copy:C1225($aSpec))
			
		End for 
		
	End if 
	
End for 

//-------------------------------
// Merge registered namespaces

ARRAY TEXT:C222($nsURIs; 0)
OB GET PROPERTY NAMES:C1232(<>gXMPNamespaces; $nsURIs)

C_LONGINT:C283($idx)

For ($idx; 1; Size of array:C274($nsURIs))
	
	C_TEXT:C284($uri)
	$uri:=$nsURIs{$idx}
	
	C_OBJECT:C1216($nsSpec)
	$nsSpec:=OB Get:C1224(<>gXMPNamespaces; $uri; Is object:K8:27)
	
	C_TEXT:C284($specPrefix)
	$specPrefix:=OB Get:C1224($nsSpec; "Prefix"; Is text:K8:3)
	
	C_TEXT:C284($registeredPrefix)
	$registeredPrefix:=XMPNS_GetPrefix:P11667:108($uri)
	
	If ($registeredPrefix="")
		If ($specPrefix="")
			$specPrefix:="dyn:"
		End if 
		$registeredPrefix:=XMPNS_Register:P11667:106($uri; $specPrefix)
	End if 
	
	OB SET:C1220($nsSpec; "Prefix"; $registeredPrefix)
	OB SET:C1220(<>gXMPNamespaces; $uri; $nsSpec)
	
End for 

//-------------------------------
// Register unregistered namespaces

ARRAY TEXT:C222($nsURIs; 0)
OB GET PROPERTY NAMES:C1232(<>gXMPNamespaces; $nsURIs)

For ($idx; 1; Size of array:C274($nsURIs))
	
	C_TEXT:C284($uri)
	$uri:=$nsURIs{$idx}
	
	C_OBJECT:C1216($nsSpec)
	$nsSpec:=OB Get:C1224(<>gXMPNamespaces; $uri; Is object:K8:27)
	
	C_TEXT:C284($specPrefix)
	$specPrefix:=OB Get:C1224($nsSpec; "Prefix"; Is text:K8:3)
	
	C_TEXT:C284($registeredPrefix)
	$registeredPrefix:=XMPNS_GetPrefix:P11667:108($uri)
	
	If ($registeredPrefix="")
		If ($specPrefix="")
			$specPrefix:="dyn:"
		End if 
		$registeredPrefix:=XMPNS_Register:P11667:106($uri; $specPrefix)
	End if 
	
	OB SET:C1220($nsSpec; "Prefix"; $registeredPrefix)
	OB SET:C1220(<>gXMPNamespaces; $uri; $nsSpec)
	
End for 
