//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$paneContext)
C_TEXT:C284($2;$propName)
C_OBJECT:C1216($3;$propSpec)

$paneContext:=$1
$propName:=$2
$propSpec:=$3

ASSERT:C1129(OB Is defined:C1231($paneContext))

C_TEXT:C284($valueColName)
$valueColName:=$propName+"_value"

C_POINTER:C301($valueColPtr)
$valueColPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$valueColName)

C_TEXT:C284($xmpDataRef)
$xmpDataRef:=OB Get:C1224($paneContext;"xmp_edit_data";Is text:K8:3)

XMPData_RemoveProperty:P11667:87 ($xmpDataRef;$propName)

ARRAY TEXT:C222($itemValues;0)
COPY ARRAY:C226($valueColPtr->;$itemValues)

C_LONGINT:C283($itemCount)
$itemCount:=Size of array:C274($itemValues)

C_LONGINT:C283($idx)

For ($idx;$itemCount;1;-1)
	If ($itemValues{$idx}="")
		DELETE FROM ARRAY:C228($itemValues;$idx)
		$itemCount:=$itemCount-1
	End if 
End for 

If ($itemCount>0)
	
	C_TEXT:C284($propType)
	$propType:=OB Get:C1224($propSpec;"Type";Is text:K8:3)
	If ($propType="bag")
		XMPData_CreateProperty:P11667:86 ($xmpDataRef;$propName;kXMPPropTypeBag)
	Else 
		XMPData_CreateProperty:P11667:86 ($xmpDataRef;$propName;kXMPPropTypeArray)
	End if 
	
	C_TEXT:C284($aValue)
	
	For ($idx;1;$itemCount)
		
		$aValue:=$itemValues{$idx}
		
		XMPData_SetSimplePropertyValue:P11667:85 ($xmpDataRef;$propName+"["+String:C10($idx)+"]";$aValue)
		
	End for 
	
End if 
