//%attributes = {"invisible":true}
C_TEXT:C284($1;$rationalText)  // @param: The rational number in string form.
C_TEXT:C284($0;$normRationalText)  // @param: The normalized rational in string form.

  // @desc: Return the normalized rational in string form.

  // @desc: Return the normalized rational in string form.
  //
  // Given a rational number in ``rationalText``, the normalized rational
  // is returned in ``normRationalText``.
  //
  // For example, with ``"1200/200"`` as input the result will be ``"12/2""``.
  //

$rationalText:=$1
$normRationalText:=$rationalText

C_TEXT:C284($nomText;$denomText)
RE_ExtractGroups ("^\\s*([0-9]+)/([0-9]+)$";$rationalText;->$nomText;->$denomText)

If (($nomText#"") & ($denomText#""))
	
	C_LONGINT:C283($nominator;$denominator)
	$nominator:=Num:C11($nomText)
	$denominator:=Num:C11($denomText)
	
	If (($nominator#0) & ($denominator#0))
		
		While (($nominator%10=0) & ($denominator%10=0))
			$nominator:=$nominator/10
			$denominator:=$denominator/10
		End while 
		
		$normRationalText:=String:C10($nominator)+"/"+String:C10($denominator)
		
	End if 
	
End if 

$0:=$normRationalText
