//%attributes = {"invisible":true}
C_TEXT:C284($1;$subPath)
C_POINTER:C301($2;$resourceRefsPtr)
C_TEXT:C284($3;$filter)

$subPath:=$1
$resourceRefsPtr:=$2
If (Count parameters:C259>2)
	$filter:=$3
End if 

Array_Clear ($resourceRefsPtr)

C_OBJECT:C1216($listingOptions)
OB SET:C1220($listingOptions;"recursive";True:C214)
If ($filter#"")
	OB SET:C1220($listingOptions;"filter";$filter)
End if 

  // ===================================
  // Fetch host db resources

ARRAY OBJECT:C1221($hostResources;0)

If (Structure file:C489#Structure file:C489(*))
	
	C_OBJECT:C1216($hostDirFSRef)
	$hostDirFSRef:=FSRef_InitWithHostResource ($subPath)
	
	FSRef_GetDirItems ($hostDirFSRef;->$hostResources;$listingOptions)
	
End if 

  // ===================================
  // Fetch component resources

ARRAY OBJECT:C1221($compResources;0)

C_TEXT:C284($resourcesDirPath)
$resourcesDirPath:=Get 4D folder:C485(Current resources folder:K5:16)

C_OBJECT:C1216($resourcesDirRef)
$resourcesDirRef:=FSRef_InitWithSystemPath ($resourcesDirPath)

C_OBJECT:C1216($compDirFSRef)
$compDirFSRef:=FSRef_AppendSubPath ($resourcesDirRef;$subPath)

FSRef_GetDirItems ($compDirFSRef;->$compResources;$listingOptions)

  // ===================================
  // Merge resources
  // Host resources override component resources with the same name.

C_LONGINT:C283($idx)
C_OBJECT:C1216($resourceFSRef)

C_OBJECT:C1216($resourcesByName)

For ($idx;1;Size of array:C274($compResources))
	$resourceFSRef:=$compResources{$idx}
	OB SET:C1220($resourcesByName;FSRef_GetName ($resourceFSRef);$resourceFSRef)
End for 

For ($idx;1;Size of array:C274($hostResources))
	$resourceFSRef:=$hostResources{$idx}
	OB SET:C1220($resourcesByName;FSRef_GetName ($resourceFSRef);$resourceFSRef)
End for 

ARRAY TEXT:C222($resourceNames;0)
OB GET PROPERTY NAMES:C1232($resourcesByName;$resourceNames)
SORT ARRAY:C229($resourceNames)

For ($idx;1;Size of array:C274($resourceNames))
	$resourceFSRef:=OB Get:C1224($resourcesByName;$resourceNames{$idx};Is object:K8:27)
	APPEND TO ARRAY:C911($resourceRefsPtr->;$resourceFSRef)
End for 

