C_LONGINT:C283($event)
$event:=Form event code:C388

Case of 
	: ($event=On Clicked:K2:4)
		
		C_LONGINT:C283($currentItemRef)
		ARRAY LONGINT:C221($selectedItemRefs; 0)
		
		$currentItemRef:=Selected list items:C379(gArchiveList; $selectedItemRefs; *)
		
		C_TEXT:C284($itemPath)
		GET LIST ITEM PARAMETER:C985(gArchiveList; $currentItemRef; "Path"; $itemPath)
		
		C_LONGINT:C283($frameIdx)
		GET LIST ITEM PARAMETER:C985(gArchiveList; $currentItemRef; "Frame"; $frameIdx)
		
		C_TEXT:C284($itemTitle)
		GET LIST ITEM:C378(gArchiveList; List item position:C629(gArchiveList; $currentItemRef); \
			$currentItemRef; $itemTitle)
		
		C_TEXT:C284($imgDocRef)
		$imgDocRef:=ImgDoc_CreateWithFile($itemPath)
		If ($imgDocRef#"")
			
			C_TEXT:C284($format)
			$format:=ImgDoc_GetFormat:P11667:9($imgDocRef)
			
			C_TEXT:C284($xmpDataRef)
			If ($format#"PDF")
				$xmpDataRef:=RasterFrame_CopyXMPData:P11667:27($imgDocRef; $frameIdx)
			Else 
				$xmpDataRef:=PDFDoc_CopyXMPData:P11667:32($imgDocRef)
			End if 
			
			If ($xmpDataRef#"")
				
				C_OBJECT:C1216($options)
				OB SET:C1220($options; "WindowTitle"; "XMP Metadata: "+$itemTitle+" / "+String:C10($frameIdx))
				OB SET:C1220($options; "DevMode"; gArchiveBrowserXMPDevMode)
				
				If (XMPDlog_EditData($xmpDataRef; $options)=1)
					If ($format#"PDF")
						RasterFrame_SetXMPData($imgDocRef; $frameIdx; $xmpDataRef)
						// FIXME: Save raster document
					Else 
						// FIXME: PDF editing
					End if 
				End if 
				
				ImgObj_Release:P11667:133($xmpDataRef)
			End if 
			
			ImgObj_Release:P11667:133($imgDocRef)
		End if 
		
	: ($event=On Long Click:K2:37)
		
		C_TEXT:C284($objectName)
		$objectName:=OBJECT Get name:C1087(Object current:K67:2)
		
		C_OBJECT:C1216($objectRect)
		$objectRect:=FormObj_GetRect($objectName)
		
		C_TEXT:C284($menuRef)
		$menuRef:=Create menu:C408
		
		APPEND MENU ITEM:C411($menuRef; "Use Developer Mode in Editor")
		If (gArchiveBrowserXMPDevMode)
			SET MENU ITEM MARK:C208($menuRef; 1; Char:C90(18))
		End if 
		SET MENU ITEM PARAMETER:C1004($menuRef; 1; "DevMode")
		
		C_TEXT:C284($selection)
		$selection:=Dynamic pop up menu:C1006($menuRef; ""; \
			RectObj_GetX($objectRect); \
			RectObj_GetY($objectRect)+RectObj_GetHeight($objectRect))
		
		RELEASE MENU:C978($menuRef)
		
		If ($selection="DevMode")
			gArchiveBrowserXMPDevMode:=Not:C34(gArchiveBrowserXMPDevMode)
		End if 
		
End case 

